c Define statement functions for difference approximations of order 6 
c Thsi file was generated by op/src/makeIncludeNew.p  
c Arguments: u,rx,dr,dx: names for the grid function, jacobian, unit square spacing and rectangular grid spacing
c To include derivatives of rx use OPTION=RX
#beginMacro defineDifferenceNewOrder6Components0(u,rx,dr,dx,OPTION)

#If #OPTION == "RX"
dr ## 16(kd) = 1./(60.*dr(kd))
dr ## 26(kd) = 1./(180.*dr(kd)**2)
#End

u ## r6(i1,i2,i3)=(45.*(u(i1+1,i2,i3)-u(i1-1,i2,i3))-9.*(u(i1+2,i2,i3)-u(i1-2,i2,i3))+(u(i1+3,i2,i3)-u(i1-3,i2,i3)))*dr ## 16(0)
u ## s6(i1,i2,i3)=(45.*(u(i1,i2+1,i3)-u(i1,i2-1,i3))-9.*(u(i1,i2+2,i3)-u(i1,i2-2,i3))+(u(i1,i2+3,i3)-u(i1,i2-3,i3)))*dr ## 16(1)
u ## t6(i1,i2,i3)=(45.*(u(i1,i2,i3+1)-u(i1,i2,i3-1))-9.*(u(i1,i2,i3+2)-u(i1,i2,i3-2))+(u(i1,i2,i3+3)-u(i1,i2,i3-3)))*dr ## 16(2)

u ## rr6(i1,i2,i3)=(-490.*u(i1,i2,i3)+270.*(u(i1+1,i2,i3)+u(i1-1,i2,i3))-27.*(u(i1+2,i2,i3)+u(i1-2,i2,i3))+2.*(u(i1+3,i2,i3)+u(i1-3,i2,i3)) )*dr ## 26(0)
u ## ss6(i1,i2,i3)=(-490.*u(i1,i2,i3)+270.*(u(i1,i2+1,i3)+u(i1,i2-1,i3))-27.*(u(i1,i2+2,i3)+u(i1,i2-2,i3))+2.*(u(i1,i2+3,i3)+u(i1,i2-3,i3)) )*dr ## 26(1)
u ## tt6(i1,i2,i3)=(-490.*u(i1,i2,i3)+270.*(u(i1,i2,i3+1)+u(i1,i2,i3-1))-27.*(u(i1,i2,i3+2)+u(i1,i2,i3-2))+2.*(u(i1,i2,i3+3)+u(i1,i2,i3-3)) )*dr ## 26(2)
u ## rs6(i1,i2,i3)=(45.*(u ## r6(i1,i2+1,i3)-u ## r6(i1,i2-1,i3))-9.*(u ## r6(i1,i2+2,i3)-u ## r6(i1,i2-2,i3))+(u ## r6(i1,i2+3,i3)-u ## r6(i1,i2-3,i3)))*dr ## 16(1)
u ## rt6(i1,i2,i3)=(45.*(u ## r6(i1,i2,i3+1)-u ## r6(i1,i2,i3-1))-9.*(u ## r6(i1,i2,i3+2)-u ## r6(i1,i2,i3-2))+(u ## r6(i1,i2,i3+3)-u ## r6(i1,i2,i3-3)))*dr ## 16(2)
u ## st6(i1,i2,i3)=(45.*(u ## s6(i1,i2,i3+1)-u ## s6(i1,i2,i3-1))-9.*(u ## s6(i1,i2,i3+2)-u ## s6(i1,i2,i3-2))+(u ## s6(i1,i2,i3+3)-u ## s6(i1,i2,i3-3)))*dr ## 16(2)

#If #OPTION == "RX"
rx ##r6(i1,i2,i3,m,n)=(45.*(rx ##(i1+1,i2,i3,m,n)-rx ##(i1-1,i2,i3,m,n))-9.*(rx ##(i1+2,i2,i3,m,n)-rx ##(i1-2,i2,i3,m,n))+(rx ##(i1+3,i2,i3,m,n)-rx ##(i1-3,i2,i3,m,n)))*dr ## 16(0)
rx ##s6(i1,i2,i3,m,n)=(45.*(rx ##(i1,i2+1,i3,m,n)-rx ##(i1,i2-1,i3,m,n))-9.*(rx ##(i1,i2+2,i3,m,n)-rx ##(i1,i2-2,i3,m,n))+(rx ##(i1,i2+3,i3,m,n)-rx ##(i1,i2-3,i3,m,n)))*dr ## 16(1)
rx ##t6(i1,i2,i3,m,n)=(45.*(rx ##(i1,i2,i3+1,m,n)-rx ##(i1,i2,i3-1,m,n))-9.*(rx ##(i1,i2,i3+2,m,n)-rx ##(i1,i2,i3-2,m,n))+(rx ##(i1,i2,i3+3,m,n)-rx ##(i1,i2,i3-3,m,n)))*dr ## 16(2)
#End

u ## x61(i1,i2,i3)= rx(i1,i2,i3,0,0)*u ## r6(i1,i2,i3)
u ## y61(i1,i2,i3)=0
u ## z61(i1,i2,i3)=0

u ## x62(i1,i2,i3)= rx(i1,i2,i3,0,0)*u ## r6(i1,i2,i3)+rx(i1,i2,i3,1,0)*u ## s6(i1,i2,i3)
u ## y62(i1,i2,i3)= rx(i1,i2,i3,0,1)*u ## r6(i1,i2,i3)+rx(i1,i2,i3,1,1)*u ## s6(i1,i2,i3)
u ## z62(i1,i2,i3)=0
u ## x63(i1,i2,i3)=rx(i1,i2,i3,0,0)*u ## r6(i1,i2,i3)+rx(i1,i2,i3,1,0)*u ## s6(i1,i2,i3)+rx(i1,i2,i3,2,0)*u ## t6(i1,i2,i3)
u ## y63(i1,i2,i3)=rx(i1,i2,i3,0,1)*u ## r6(i1,i2,i3)+rx(i1,i2,i3,1,1)*u ## s6(i1,i2,i3)+rx(i1,i2,i3,2,1)*u ## t6(i1,i2,i3)
u ## z63(i1,i2,i3)=rx(i1,i2,i3,0,2)*u ## r6(i1,i2,i3)+rx(i1,i2,i3,1,2)*u ## s6(i1,i2,i3)+rx(i1,i2,i3,2,2)*u ## t6(i1,i2,i3)

#If #OPTION == "RX"
rx ## x61(i1,i2,i3,m,n)= rx(i1,i2,i3,0,0)*rx ##r6(i1,i2,i3,m,n)
rx ##x62(i1,i2,i3,m,n)= rx(i1,i2,i3,0,0)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,0)*rx ##s6(i1,i2,i3,m,n)
rx ##y62(i1,i2,i3,m,n)= rx(i1,i2,i3,0,1)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,1)*rx ##s6(i1,i2,i3,m,n)
rx ##x63(i1,i2,i3,m,n)=rx(i1,i2,i3,0,0)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,0)*rx ##s6(i1,i2,i3,m,n)+rx(i1,i2,i3,2,0)*rx ##t6(i1,i2,i3,m,n)
rx ##y63(i1,i2,i3,m,n)=rx(i1,i2,i3,0,1)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,1)*rx ##s6(i1,i2,i3,m,n)+rx(i1,i2,i3,2,1)*rx ##t6(i1,i2,i3,m,n)
rx ##z63(i1,i2,i3,m,n)=rx(i1,i2,i3,0,2)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,2)*rx ##s6(i1,i2,i3,m,n)+rx(i1,i2,i3,2,2)*rx ##t6(i1,i2,i3,m,n)
#End

u ## xx61(i1,i2,i3)=(rx(i1,i2,i3,0,0)**2)*u ## rr6(i1,i2,i3)+(rx ## x6 ## 2(i1,i2,i3,0,0))*u ## r6(i1,i2,i3)
u ## yy61(i1,i2,i3)=0
u ## xy61(i1,i2,i3)=0
u ## xz61(i1,i2,i3)=0
u ## yz61(i1,i2,i3)=0
u ## zz61(i1,i2,i3)=0
u ## laplacian61(i1,i2,i3)=u ## xx61(i1,i2,i3)
u ## xx62(i1,i2,i3)=(rx(i1,i2,i3,0,0)**2)*u ## rr6(i1,i2,i3)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0))*u ## rs6(i1,i2,i3)+(rx(i1,i2,i3,1,0)**2)*u ## ss6(i1,i2,i3)+(rx ## x6 ## 2(i1,i2,i3,0,0))*u ## r6(i1,i2,i3)+(rx ## x6 ## 2(i1,i2,i3,1,0))*u ## s6(i1,i2,i3)
u ## yy62(i1,i2,i3)=(rx(i1,i2,i3,0,1)**2)*u ## rr6(i1,i2,i3)+2.*(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1))*u ## rs6(i1,i2,i3)+(rx(i1,i2,i3,1,1)**2)*u ## ss6(i1,i2,i3)+(rx ## y6 ## 2(i1,i2,i3,0,1))*u ## r6(i1,i2,i3)+(rx ## y6 ## 2(i1,i2,i3,1,1))*u ## s6(i1,i2,i3)
u ## xy62(i1,i2,i3)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,1)*u ## rr6(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,0))*u ## rs6(i1,i2,i3)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,1)*u ## ss6(i1,i2,i3)+rx ## x6 ## 2(i1,i2,i3,0,1)*u ## r6(i1,i2,i3)+rx ## x6 ## 2(i1,i2,i3,1,1)*u ## s6(i1,i2,i3)
u ## xz62(i1,i2,i3)=0
u ## yz62(i1,i2,i3)=0
u ## zz62(i1,i2,i3)=0
u ## laplacian62(i1,i2,i3)=(rx(i1,i2,i3,0,0)**2+rx(i1,i2,i3,0,1)**2)*u ## rr6(i1,i2,i3)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1))*u ## rs6(i1,i2,i3)+(rx(i1,i2,i3,1,0)**2+rx(i1,i2,i3,1,1)**2)*u ## ss6(i1,i2,i3)+(rx ## x6 ## 2(i1,i2,i3,0,0)+rx ## y6 ## 2(i1,i2,i3,0,1))*u ## r6(i1,i2,i3)+(rx ## x6 ## 2(i1,i2,i3,1,0)+rx ## y6 ## 2(i1,i2,i3,1,1))*u ## s6(i1,i2,i3)
u ## xx63(i1,i2,i3)=rx(i1,i2,i3,0,0)**2*u ## rr6(i1,i2,i3)+rx(i1,i2,i3,1,0)**2*u ## ss6(i1,i2,i3)+rx(i1,i2,i3,2,0)**2*u ## tt6(i1,i2,i3)+2.*rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)*u ## rs6(i1,i2,i3)+2.*rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,0)*u ## rt6(i1,i2,i3)+2.*rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,0)*u ## st6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,0,0)*u ## r6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,1,0)*u ## s6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,2,0)*u ## t6(i1,i2,i3)
u ## yy63(i1,i2,i3)=rx(i1,i2,i3,0,1)**2*u ## rr6(i1,i2,i3)+rx(i1,i2,i3,1,1)**2*u ## ss6(i1,i2,i3)+rx(i1,i2,i3,2,1)**2*u ## tt6(i1,i2,i3)+2.*rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1)*u ## rs6(i1,i2,i3)+2.*rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,1)*u ## rt6(i1,i2,i3)+2.*rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,1)*u ## st6(i1,i2,i3)+rx ## y6 ## 3(i1,i2,i3,0,1)*u ## r6(i1,i2,i3)+rx ## y6 ## 3(i1,i2,i3,1,1)*u ## s6(i1,i2,i3)+rx ## y6 ## 3(i1,i2,i3,2,1)*u ## t6(i1,i2,i3)
u ## zz63(i1,i2,i3)=rx(i1,i2,i3,0,2)**2*u ## rr6(i1,i2,i3)+rx(i1,i2,i3,1,2)**2*u ## ss6(i1,i2,i3)+rx(i1,i2,i3,2,2)**2*u ## tt6(i1,i2,i3)+2.*rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,2)*u ## rs6(i1,i2,i3)+2.*rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,2)*u ## rt6(i1,i2,i3)+2.*rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,2)*u ## st6(i1,i2,i3)+rx ## z6 ## 3(i1,i2,i3,0,2)*u ## r6(i1,i2,i3)+rx ## z6 ## 3(i1,i2,i3,1,2)*u ## s6(i1,i2,i3)+rx ## z6 ## 3(i1,i2,i3,2,2)*u ## t6(i1,i2,i3)
u ## xy63(i1,i2,i3)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,1)*u ## rr6(i1,i2,i3)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,1)*u ## ss6(i1,i2,i3)+rx(i1,i2,i3,2,0)*rx(i1,i2,i3,2,1)*u ## tt6(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,0))*u ## rs6(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,0))*u ## rt6(i1,i2,i3)+(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,0))*u ## st6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,0,1)*u ## r6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,1,1)*u ## s6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,2,1)*u ## t6(i1,i2,i3)
u ## xz63(i1,i2,i3)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,2)*u ## rr6(i1,i2,i3)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,2)*u ## ss6(i1,i2,i3)+rx(i1,i2,i3,2,0)*rx(i1,i2,i3,2,2)*u ## tt6(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,0))*u ## rs6(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,0))*u ## rt6(i1,i2,i3)+(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,0))*u ## st6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,0,2)*u ## r6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,1,2)*u ## s6(i1,i2,i3)+rx ## x6 ## 3(i1,i2,i3,2,2)*u ## t6(i1,i2,i3)
u ## yz63(i1,i2,i3)=rx(i1,i2,i3,0,1)*rx(i1,i2,i3,0,2)*u ## rr6(i1,i2,i3)+rx(i1,i2,i3,1,1)*rx(i1,i2,i3,1,2)*u ## ss6(i1,i2,i3)+rx(i1,i2,i3,2,1)*rx(i1,i2,i3,2,2)*u ## tt6(i1,i2,i3)+(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,1))*u ## rs6(i1,i2,i3)+(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,1))*u ## rt6(i1,i2,i3)+(rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,1))*u ## st6(i1,i2,i3)+rx ## y6 ## 3(i1,i2,i3,0,2)*u ## r6(i1,i2,i3)+rx ## y6 ## 3(i1,i2,i3,1,2)*u ## s6(i1,i2,i3)+rx ## y6 ## 3(i1,i2,i3,2,2)*u ## t6(i1,i2,i3)
u ## laplacian63(i1,i2,i3)=(rx(i1,i2,i3,0,0)**2+rx(i1,i2,i3,0,1)**2+rx(i1,i2,i3,0,2)**2)*u ## rr6(i1,i2,i3)+(rx(i1,i2,i3,1,0)**2+rx(i1,i2,i3,1,1)**2+rx(i1,i2,i3,1,2)**2)*u ## ss6(i1,i2,i3)+(rx(i1,i2,i3,2,0)**2+rx(i1,i2,i3,2,1)**2+rx(i1,i2,i3,2,2)**2)*u ## tt6(i1,i2,i3)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,2))*u ## rs6(i1,i2,i3)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,2))*u ## rt6(i1,i2,i3)+2.*(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,0)+ rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,2))*u ## st6(i1,i2,i3)+(rx ## x6 ## 3(i1,i2,i3,0,0)+rx ## y6 ## 3(i1,i2,i3,0,1)+rx ## z6 ## 3(i1,i2,i3,0,2))*u ## r6(i1,i2,i3)+(rx ## x6 ## 3(i1,i2,i3,1,0)+rx ## y6 ## 3(i1,i2,i3,1,1)+rx ## z6 ## 3(i1,i2,i3,1,2))*u ## s6(i1,i2,i3)+(rx ## x6 ## 3(i1,i2,i3,2,0)+rx ## y6 ## 3(i1,i2,i3,2,1)+rx ## z6 ## 3(i1,i2,i3,2,2))*u ## t6(i1,i2,i3)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
#If #OPTION == "RX"
dx ## 16(kd) = 1./(60.*dx(kd))
dx ## 26(kd) = 1./(180.*dx(kd)**2)
#End

u ## x63r(i1,i2,i3)=(45.*(u(i1+1,i2,i3)-u(i1-1,i2,i3))-9.*(u(i1+2,i2,i3)-u(i1-2,i2,i3))+(u(i1+3,i2,i3)-u(i1-3,i2,i3)))*dx ## 16(0)
u ## y63r(i1,i2,i3)=(45.*(u(i1,i2+1,i3)-u(i1,i2-1,i3))-9.*(u(i1,i2+2,i3)-u(i1,i2-2,i3))+(u(i1,i2+3,i3)-u(i1,i2-3,i3)))*dx ## 16(1)
u ## z63r(i1,i2,i3)=(45.*(u(i1,i2,i3+1)-u(i1,i2,i3-1))-9.*(u(i1,i2,i3+2)-u(i1,i2,i3-2))+(u(i1,i2,i3+3)-u(i1,i2,i3-3)))*dx ## 16(2)

u ## xx63r(i1,i2,i3)=(-490.*u(i1,i2,i3)+270.*(u(i1+1,i2,i3)+u(i1-1,i2,i3))-27.*(u(i1+2,i2,i3)+u(i1-2,i2,i3))+2.*(u(i1+3,i2,i3)+u(i1-3,i2,i3)) )*dx ## 26(0)
u ## yy63r(i1,i2,i3)=(-490.*u(i1,i2,i3)+270.*(u(i1,i2+1,i3)+u(i1,i2-1,i3))-27.*(u(i1,i2+2,i3)+u(i1,i2-2,i3))+2.*(u(i1,i2+3,i3)+u(i1,i2-3,i3)) )*dx ## 26(1)
u ## zz63r(i1,i2,i3)=(-490.*u(i1,i2,i3)+270.*(u(i1,i2,i3+1)+u(i1,i2,i3-1))-27.*(u(i1,i2,i3+2)+u(i1,i2,i3-2))+2.*(u(i1,i2,i3+3)+u(i1,i2,i3-3)) )*dx ## 26(2)
u ## xy63r(i1,i2,i3)=(45.*(u ## x63r(i1,i2+1,i3)-u ## x63r(i1,i2-1,i3))-9.*(u ## x63r(i1,i2+2,i3)-u ## x63r(i1,i2-2,i3))+(u ## x63r(i1,i2+3,i3)-u ## x63r(i1,i2-3,i3)))*dx ## 16(1)
u ## xz63r(i1,i2,i3)=(45.*(u ## x63r(i1,i2,i3+1)-u ## x63r(i1,i2,i3-1))-9.*(u ## x63r(i1,i2,i3+2)-u ## x63r(i1,i2,i3-2))+(u ## x63r(i1,i2,i3+3)-u ## x63r(i1,i2,i3-3)))*dx ## 16(2)
u ## yz63r(i1,i2,i3)=(45.*(u ## y63r(i1,i2,i3+1)-u ## y63r(i1,i2,i3-1))-9.*(u ## y63r(i1,i2,i3+2)-u ## y63r(i1,i2,i3-2))+(u ## y63r(i1,i2,i3+3)-u ## y63r(i1,i2,i3-3)))*dx ## 16(2)

u ## x61r(i1,i2,i3)= u ## x63r(i1,i2,i3)
u ## y61r(i1,i2,i3)= u ## y63r(i1,i2,i3)
u ## z61r(i1,i2,i3)= u ## z63r(i1,i2,i3)
u ## xx61r(i1,i2,i3)= u ## xx63r(i1,i2,i3)
u ## yy61r(i1,i2,i3)= u ## yy63r(i1,i2,i3)
u ## zz61r(i1,i2,i3)= u ## zz63r(i1,i2,i3)
u ## xy61r(i1,i2,i3)= u ## xy63r(i1,i2,i3)
u ## xz61r(i1,i2,i3)= u ## xz63r(i1,i2,i3)
u ## yz61r(i1,i2,i3)= u ## yz63r(i1,i2,i3)
u ## laplacian61r(i1,i2,i3)=u ## xx63r(i1,i2,i3)
u ## x62r(i1,i2,i3)= u ## x63r(i1,i2,i3)
u ## y62r(i1,i2,i3)= u ## y63r(i1,i2,i3)
u ## z62r(i1,i2,i3)= u ## z63r(i1,i2,i3)
u ## xx62r(i1,i2,i3)= u ## xx63r(i1,i2,i3)
u ## yy62r(i1,i2,i3)= u ## yy63r(i1,i2,i3)
u ## zz62r(i1,i2,i3)= u ## zz63r(i1,i2,i3)
u ## xy62r(i1,i2,i3)= u ## xy63r(i1,i2,i3)
u ## xz62r(i1,i2,i3)= u ## xz63r(i1,i2,i3)
u ## yz62r(i1,i2,i3)= u ## yz63r(i1,i2,i3)
u ## laplacian62r(i1,i2,i3)=u ## xx63r(i1,i2,i3)+u ## yy63r(i1,i2,i3)
u ## laplacian63r(i1,i2,i3)=u ## xx63r(i1,i2,i3)+u ## yy63r(i1,i2,i3)+u ## zz63r(i1,i2,i3)
#endMacro
c Arguments: u,rx,dr,dx: names for the grid function, jacobian, unit square spacing and rectangular grid spacing
c To include derivatives of rx use OPTION=RX
#beginMacro defineDifferenceNewOrder6Components1(u,rx,dr,dx,OPTION)

#If #OPTION == "RX"
dr ## 16(kd) = 1./(60.*dr(kd))
dr ## 26(kd) = 1./(180.*dr(kd)**2)
#End

u ## r6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,i3,kd)))*dr ## 16(0)
u ## s6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,i3,kd)))*dr ## 16(1)
u ## t6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-3,kd)))*dr ## 16(2)

u ## rr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*dr ## 26(0)
u ## ss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*dr ## 26(1)
u ## tt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*dr ## 26(2)
u ## rs6(i1,i2,i3,kd)=(45.*(u ## r6(i1,i2+1,i3,kd)-u ## r6(i1,i2-1,i3,kd))-9.*(u ## r6(i1,i2+2,i3,kd)-u ## r6(i1,i2-2,i3,kd))+(u ## r6(i1,i2+3,i3,kd)-u ## r6(i1,i2-3,i3,kd)))*dr ## 16(1)
u ## rt6(i1,i2,i3,kd)=(45.*(u ## r6(i1,i2,i3+1,kd)-u ## r6(i1,i2,i3-1,kd))-9.*(u ## r6(i1,i2,i3+2,kd)-u ## r6(i1,i2,i3-2,kd))+(u ## r6(i1,i2,i3+3,kd)-u ## r6(i1,i2,i3-3,kd)))*dr ## 16(2)
u ## st6(i1,i2,i3,kd)=(45.*(u ## s6(i1,i2,i3+1,kd)-u ## s6(i1,i2,i3-1,kd))-9.*(u ## s6(i1,i2,i3+2,kd)-u ## s6(i1,i2,i3-2,kd))+(u ## s6(i1,i2,i3+3,kd)-u ## s6(i1,i2,i3-3,kd)))*dr ## 16(2)

#If #OPTION == "RX"
rx ##r6(i1,i2,i3,m,n)=(45.*(rx ##(i1+1,i2,i3,m,n)-rx ##(i1-1,i2,i3,m,n))-9.*(rx ##(i1+2,i2,i3,m,n)-rx ##(i1-2,i2,i3,m,n))+(rx ##(i1+3,i2,i3,m,n)-rx ##(i1-3,i2,i3,m,n)))*dr ## 16(0)
rx ##s6(i1,i2,i3,m,n)=(45.*(rx ##(i1,i2+1,i3,m,n)-rx ##(i1,i2-1,i3,m,n))-9.*(rx ##(i1,i2+2,i3,m,n)-rx ##(i1,i2-2,i3,m,n))+(rx ##(i1,i2+3,i3,m,n)-rx ##(i1,i2-3,i3,m,n)))*dr ## 16(1)
rx ##t6(i1,i2,i3,m,n)=(45.*(rx ##(i1,i2,i3+1,m,n)-rx ##(i1,i2,i3-1,m,n))-9.*(rx ##(i1,i2,i3+2,m,n)-rx ##(i1,i2,i3-2,m,n))+(rx ##(i1,i2,i3+3,m,n)-rx ##(i1,i2,i3-3,m,n)))*dr ## 16(2)
#End

u ## x61(i1,i2,i3,kd)= rx(i1,i2,i3,0,0)*u ## r6(i1,i2,i3,kd)
u ## y61(i1,i2,i3,kd)=0
u ## z61(i1,i2,i3,kd)=0

u ## x62(i1,i2,i3,kd)= rx(i1,i2,i3,0,0)*u ## r6(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*u ## s6(i1,i2,i3,kd)
u ## y62(i1,i2,i3,kd)= rx(i1,i2,i3,0,1)*u ## r6(i1,i2,i3,kd)+rx(i1,i2,i3,1,1)*u ## s6(i1,i2,i3,kd)
u ## z62(i1,i2,i3,kd)=0
u ## x63(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)*u ## r6(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*u ## s6(i1,i2,i3,kd)+rx(i1,i2,i3,2,0)*u ## t6(i1,i2,i3,kd)
u ## y63(i1,i2,i3,kd)=rx(i1,i2,i3,0,1)*u ## r6(i1,i2,i3,kd)+rx(i1,i2,i3,1,1)*u ## s6(i1,i2,i3,kd)+rx(i1,i2,i3,2,1)*u ## t6(i1,i2,i3,kd)
u ## z63(i1,i2,i3,kd)=rx(i1,i2,i3,0,2)*u ## r6(i1,i2,i3,kd)+rx(i1,i2,i3,1,2)*u ## s6(i1,i2,i3,kd)+rx(i1,i2,i3,2,2)*u ## t6(i1,i2,i3,kd)

#If #OPTION == "RX"
rx ## x61(i1,i2,i3,m,n)= rx(i1,i2,i3,0,0)*rx ##r6(i1,i2,i3,m,n)
rx ##x62(i1,i2,i3,m,n)= rx(i1,i2,i3,0,0)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,0)*rx ##s6(i1,i2,i3,m,n)
rx ##y62(i1,i2,i3,m,n)= rx(i1,i2,i3,0,1)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,1)*rx ##s6(i1,i2,i3,m,n)
rx ##x63(i1,i2,i3,m,n)=rx(i1,i2,i3,0,0)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,0)*rx ##s6(i1,i2,i3,m,n)+rx(i1,i2,i3,2,0)*rx ##t6(i1,i2,i3,m,n)
rx ##y63(i1,i2,i3,m,n)=rx(i1,i2,i3,0,1)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,1)*rx ##s6(i1,i2,i3,m,n)+rx(i1,i2,i3,2,1)*rx ##t6(i1,i2,i3,m,n)
rx ##z63(i1,i2,i3,m,n)=rx(i1,i2,i3,0,2)*rx ##r6(i1,i2,i3,m,n)+rx(i1,i2,i3,1,2)*rx ##s6(i1,i2,i3,m,n)+rx(i1,i2,i3,2,2)*rx ##t6(i1,i2,i3,m,n)
#End

u ## xx61(i1,i2,i3,kd)=(rx(i1,i2,i3,0,0)**2)*u ## rr6(i1,i2,i3,kd)+(rx ## x6 ## 2(i1,i2,i3,0,0))*u ## r6(i1,i2,i3,kd)
u ## yy61(i1,i2,i3,kd)=0
u ## xy61(i1,i2,i3,kd)=0
u ## xz61(i1,i2,i3,kd)=0
u ## yz61(i1,i2,i3,kd)=0
u ## zz61(i1,i2,i3,kd)=0
u ## laplacian61(i1,i2,i3,kd)=u ## xx61(i1,i2,i3,kd)
u ## xx62(i1,i2,i3,kd)=(rx(i1,i2,i3,0,0)**2)*u ## rr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0))*u ## rs6(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)**2)*u ## ss6(i1,i2,i3,kd)+(rx ## x6 ## 2(i1,i2,i3,0,0))*u ## r6(i1,i2,i3,kd)+(rx ## x6 ## 2(i1,i2,i3,1,0))*u ## s6(i1,i2,i3,kd)
u ## yy62(i1,i2,i3,kd)=(rx(i1,i2,i3,0,1)**2)*u ## rr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1))*u ## rs6(i1,i2,i3,kd)+(rx(i1,i2,i3,1,1)**2)*u ## ss6(i1,i2,i3,kd)+(rx ## y6 ## 2(i1,i2,i3,0,1))*u ## r6(i1,i2,i3,kd)+(rx ## y6 ## 2(i1,i2,i3,1,1))*u ## s6(i1,i2,i3,kd)
u ## xy62(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,1)*u ## rr6(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,0))*u ## rs6(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,1)*u ## ss6(i1,i2,i3,kd)+rx ## x6 ## 2(i1,i2,i3,0,1)*u ## r6(i1,i2,i3,kd)+rx ## x6 ## 2(i1,i2,i3,1,1)*u ## s6(i1,i2,i3,kd)
u ## xz62(i1,i2,i3,kd)=0
u ## yz62(i1,i2,i3,kd)=0
u ## zz62(i1,i2,i3,kd)=0
u ## laplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3,0,0)**2+rx(i1,i2,i3,0,1)**2)*u ## rr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1))*u ## rs6(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)**2+rx(i1,i2,i3,1,1)**2)*u ## ss6(i1,i2,i3,kd)+(rx ## x6 ## 2(i1,i2,i3,0,0)+rx ## y6 ## 2(i1,i2,i3,0,1))*u ## r6(i1,i2,i3,kd)+(rx ## x6 ## 2(i1,i2,i3,1,0)+rx ## y6 ## 2(i1,i2,i3,1,1))*u ## s6(i1,i2,i3,kd)
u ## xx63(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)**2*u ## rr6(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)**2*u ## ss6(i1,i2,i3,kd)+rx(i1,i2,i3,2,0)**2*u ## tt6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)*u ## rs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,0)*u ## rt6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,0)*u ## st6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,0,0)*u ## r6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,1,0)*u ## s6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,2,0)*u ## t6(i1,i2,i3,kd)
u ## yy63(i1,i2,i3,kd)=rx(i1,i2,i3,0,1)**2*u ## rr6(i1,i2,i3,kd)+rx(i1,i2,i3,1,1)**2*u ## ss6(i1,i2,i3,kd)+rx(i1,i2,i3,2,1)**2*u ## tt6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1)*u ## rs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,1)*u ## rt6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,1)*u ## st6(i1,i2,i3,kd)+rx ## y6 ## 3(i1,i2,i3,0,1)*u ## r6(i1,i2,i3,kd)+rx ## y6 ## 3(i1,i2,i3,1,1)*u ## s6(i1,i2,i3,kd)+rx ## y6 ## 3(i1,i2,i3,2,1)*u ## t6(i1,i2,i3,kd)
u ## zz63(i1,i2,i3,kd)=rx(i1,i2,i3,0,2)**2*u ## rr6(i1,i2,i3,kd)+rx(i1,i2,i3,1,2)**2*u ## ss6(i1,i2,i3,kd)+rx(i1,i2,i3,2,2)**2*u ## tt6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,2)*u ## rs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,2)*u ## rt6(i1,i2,i3,kd)+2.*rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,2)*u ## st6(i1,i2,i3,kd)+rx ## z6 ## 3(i1,i2,i3,0,2)*u ## r6(i1,i2,i3,kd)+rx ## z6 ## 3(i1,i2,i3,1,2)*u ## s6(i1,i2,i3,kd)+rx ## z6 ## 3(i1,i2,i3,2,2)*u ## t6(i1,i2,i3,kd)
u ## xy63(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,1)*u ## rr6(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,1)*u ## ss6(i1,i2,i3,kd)+rx(i1,i2,i3,2,0)*rx(i1,i2,i3,2,1)*u ## tt6(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,0))*u ## rs6(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,0))*u ## rt6(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,0))*u ## st6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,0,1)*u ## r6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,1,1)*u ## s6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,2,1)*u ## t6(i1,i2,i3,kd)
u ## xz63(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,2)*u ## rr6(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,2)*u ## ss6(i1,i2,i3,kd)+rx(i1,i2,i3,2,0)*rx(i1,i2,i3,2,2)*u ## tt6(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,0))*u ## rs6(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,0))*u ## rt6(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,0))*u ## st6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,0,2)*u ## r6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,1,2)*u ## s6(i1,i2,i3,kd)+rx ## x6 ## 3(i1,i2,i3,2,2)*u ## t6(i1,i2,i3,kd)
u ## yz63(i1,i2,i3,kd)=rx(i1,i2,i3,0,1)*rx(i1,i2,i3,0,2)*u ## rr6(i1,i2,i3,kd)+rx(i1,i2,i3,1,1)*rx(i1,i2,i3,1,2)*u ## ss6(i1,i2,i3,kd)+rx(i1,i2,i3,2,1)*rx(i1,i2,i3,2,2)*u ## tt6(i1,i2,i3,kd)+(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,1))*u ## rs6(i1,i2,i3,kd)+(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,1))*u ## rt6(i1,i2,i3,kd)+(rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,1))*u ## st6(i1,i2,i3,kd)+rx ## y6 ## 3(i1,i2,i3,0,2)*u ## r6(i1,i2,i3,kd)+rx ## y6 ## 3(i1,i2,i3,1,2)*u ## s6(i1,i2,i3,kd)+rx ## y6 ## 3(i1,i2,i3,2,2)*u ## t6(i1,i2,i3,kd)
u ## laplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3,0,0)**2+rx(i1,i2,i3,0,1)**2+rx(i1,i2,i3,0,2)**2)*u ## rr6(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)**2+rx(i1,i2,i3,1,1)**2+rx(i1,i2,i3,1,2)**2)*u ## ss6(i1,i2,i3,kd)+(rx(i1,i2,i3,2,0)**2+rx(i1,i2,i3,2,1)**2+rx(i1,i2,i3,2,2)**2)*u ## tt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,2))*u ## rs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,2))*u ## rt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,0)+ rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,2))*u ## st6(i1,i2,i3,kd)+(rx ## x6 ## 3(i1,i2,i3,0,0)+rx ## y6 ## 3(i1,i2,i3,0,1)+rx ## z6 ## 3(i1,i2,i3,0,2))*u ## r6(i1,i2,i3,kd)+(rx ## x6 ## 3(i1,i2,i3,1,0)+rx ## y6 ## 3(i1,i2,i3,1,1)+rx ## z6 ## 3(i1,i2,i3,1,2))*u ## s6(i1,i2,i3,kd)+(rx ## x6 ## 3(i1,i2,i3,2,0)+rx ## y6 ## 3(i1,i2,i3,2,1)+rx ## z6 ## 3(i1,i2,i3,2,2))*u ## t6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
#If #OPTION == "RX"
dx ## 16(kd) = 1./(60.*dx(kd))
dx ## 26(kd) = 1./(180.*dx(kd)**2)
#End

u ## x63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,i3,kd)))*dx ## 16(0)
u ## y63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,i3,kd)))*dx ## 16(1)
u ## z63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-3,kd)))*dx ## 16(2)

u ## xx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*dx ## 26(0)
u ## yy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*dx ## 26(1)
u ## zz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*dx ## 26(2)
u ## xy63r(i1,i2,i3,kd)=(45.*(u ## x63r(i1,i2+1,i3,kd)-u ## x63r(i1,i2-1,i3,kd))-9.*(u ## x63r(i1,i2+2,i3,kd)-u ## x63r(i1,i2-2,i3,kd))+(u ## x63r(i1,i2+3,i3,kd)-u ## x63r(i1,i2-3,i3,kd)))*dx ## 16(1)
u ## xz63r(i1,i2,i3,kd)=(45.*(u ## x63r(i1,i2,i3+1,kd)-u ## x63r(i1,i2,i3-1,kd))-9.*(u ## x63r(i1,i2,i3+2,kd)-u ## x63r(i1,i2,i3-2,kd))+(u ## x63r(i1,i2,i3+3,kd)-u ## x63r(i1,i2,i3-3,kd)))*dx ## 16(2)
u ## yz63r(i1,i2,i3,kd)=(45.*(u ## y63r(i1,i2,i3+1,kd)-u ## y63r(i1,i2,i3-1,kd))-9.*(u ## y63r(i1,i2,i3+2,kd)-u ## y63r(i1,i2,i3-2,kd))+(u ## y63r(i1,i2,i3+3,kd)-u ## y63r(i1,i2,i3-3,kd)))*dx ## 16(2)

u ## x61r(i1,i2,i3,kd)= u ## x63r(i1,i2,i3,kd)
u ## y61r(i1,i2,i3,kd)= u ## y63r(i1,i2,i3,kd)
u ## z61r(i1,i2,i3,kd)= u ## z63r(i1,i2,i3,kd)
u ## xx61r(i1,i2,i3,kd)= u ## xx63r(i1,i2,i3,kd)
u ## yy61r(i1,i2,i3,kd)= u ## yy63r(i1,i2,i3,kd)
u ## zz61r(i1,i2,i3,kd)= u ## zz63r(i1,i2,i3,kd)
u ## xy61r(i1,i2,i3,kd)= u ## xy63r(i1,i2,i3,kd)
u ## xz61r(i1,i2,i3,kd)= u ## xz63r(i1,i2,i3,kd)
u ## yz61r(i1,i2,i3,kd)= u ## yz63r(i1,i2,i3,kd)
u ## laplacian61r(i1,i2,i3,kd)=u ## xx63r(i1,i2,i3,kd)
u ## x62r(i1,i2,i3,kd)= u ## x63r(i1,i2,i3,kd)
u ## y62r(i1,i2,i3,kd)= u ## y63r(i1,i2,i3,kd)
u ## z62r(i1,i2,i3,kd)= u ## z63r(i1,i2,i3,kd)
u ## xx62r(i1,i2,i3,kd)= u ## xx63r(i1,i2,i3,kd)
u ## yy62r(i1,i2,i3,kd)= u ## yy63r(i1,i2,i3,kd)
u ## zz62r(i1,i2,i3,kd)= u ## zz63r(i1,i2,i3,kd)
u ## xy62r(i1,i2,i3,kd)= u ## xy63r(i1,i2,i3,kd)
u ## xz62r(i1,i2,i3,kd)= u ## xz63r(i1,i2,i3,kd)
u ## yz62r(i1,i2,i3,kd)= u ## yz63r(i1,i2,i3,kd)
u ## laplacian62r(i1,i2,i3,kd)=u ## xx63r(i1,i2,i3,kd)+u ## yy63r(i1,i2,i3,kd)
u ## laplacian63r(i1,i2,i3,kd)=u ## xx63r(i1,i2,i3,kd)+u ## yy63r(i1,i2,i3,kd)+u ## zz63r(i1,i2,i3,kd)
#endMacro


#beginMacro declareDifferenceNewOrder6(u,rx,dr,dx,OPTION)
real dr ##16
real dr ##26
real u ##r6
real u ##s6
real u ##t6
real u ##rr6
real u ##ss6
real u ##tt6
real u ##rs6
real u ##rt6
real u ##st6
real rx ##r6
real rx ##s6
real rx ##t6
real u ##x61
real u ##y61
real u ##z61
real u ##x62
real u ##y62
real u ##z62
real u ##x63
real u ##y63
real u ##z63
real rx ##x61
real rx ##x62
real rx ##y62
real rx ##x63
real rx ##y63
real rx ##z63
real u ##xx61
real u ##yy61
real u ##xy61
real u ##xz61
real u ##yz61
real u ##zz61
real u ##laplacian61
real u ##xx62
real u ##yy62
real u ##xy62
real u ##xz62
real u ##yz62
real u ##zz62
real u ##laplacian62
real u ##xx63
real u ##yy63
real u ##zz63
real u ##xy63
real u ##xz63
real u ##yz63
real u ##laplacian63
real dx ##16
real dx ##26
real u ##x63r
real u ##y63r
real u ##z63r
real u ##xx63r
real u ##yy63r
real u ##zz63r
real u ##xy63r
real u ##xz63r
real u ##yz63r
real u ##x61r
real u ##y61r
real u ##z61r
real u ##xx61r
real u ##yy61r
real u ##zz61r
real u ##xy61r
real u ##xz61r
real u ##yz61r
real u ##laplacian61r
real u ##x62r
real u ##y62r
real u ##z62r
real u ##xx62r
real u ##yy62r
real u ##zz62r
real u ##xy62r
real u ##xz62r
real u ##yz62r
real u ##laplacian62r
real u ##laplacian63r
#endMacro
