! This file, opStencilCoeff.h,  was generated by Overture/op/src/stencilCoeff.maple

! ****************************************************************************** 
! **** This file contains bpp macros to evaluate the coefficient matrix for **** 
! **** derivatives such as x,y,z,xx,yy,zz,laplacian,rr,ss,tt,rrrr,ssss      **** 
! ****************************************************************************** 


! *** dim=2, orderOfAccuracy = 2 *** 

#beginMacro xCoeffOrder2Dim2(coeff,aj)
! Operator x = rx*ur+sx*us
 cur = aj ## rx
 cus = aj ## sx
 coeff(ma2(-1,-1, 0)) = 0 
 coeff(ma2( 0,-1, 0)) = -1/2.*cus/(dr(1)) 
 coeff(ma2( 1,-1, 0)) = 0 
 coeff(ma2(-1, 0, 0)) = -1/2.*cur/(dr(0)) 
 coeff(ma2( 0, 0, 0)) = 0 
 coeff(ma2( 1, 0, 0)) = 1/2.*cur/(dr(0)) 
 coeff(ma2(-1, 1, 0)) = 0 
 coeff(ma2( 0, 1, 0)) = 1/2.*cus/(dr(1)) 
 coeff(ma2( 1, 1, 0)) = 0 
#endMacro

#beginMacro yCoeffOrder2Dim2(coeff,aj)
! Operator y = ry*ur+sy*us
 cur = aj ## ry
 cus = aj ## sy
 coeff(ma2(-1,-1, 0)) = 0 
 coeff(ma2( 0,-1, 0)) = -1/2.*cus/(dr(1)) 
 coeff(ma2( 1,-1, 0)) = 0 
 coeff(ma2(-1, 0, 0)) = -1/2.*cur/(dr(0)) 
 coeff(ma2( 0, 0, 0)) = 0 
 coeff(ma2( 1, 0, 0)) = 1/2.*cur/(dr(0)) 
 coeff(ma2(-1, 1, 0)) = 0 
 coeff(ma2( 0, 1, 0)) = 1/2.*cus/(dr(1)) 
 coeff(ma2( 1, 1, 0)) = 0 
#endMacro

#beginMacro laplacianCoeffOrder2Dim2(coeff,aj)
! Operator laplacian = rx^2*urr+2*rx*sx*urs+sx^2*uss+rxx*ur+sxx*us+ry^2*urr+2*ry*sy*urs+sy^2*uss+ryy*ur+syy*us
 cur = aj ## rxx+aj ## ryy
 curr = aj ## rx**2+aj ## ry**2
 cus = aj ## sxx+aj ## syy
 curs = 2.*aj ## rx*aj ## sx+2.*aj ## ry*aj ## sy
 cuss = aj ## sx**2+aj ## sy**2
 coeff(ma2(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma2( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma2( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2 
 coeff(ma2( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma2(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma2( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
#endMacro

#beginMacro xxCoeffOrder2Dim2(coeff,aj)
! Operator xx = rx^2*urr+2*rx*sx*urs+sx^2*uss+rxx*ur+sxx*us
 cur = aj ## rxx
 curr = aj ## rx**2
 cus = aj ## sxx
 curs = 2.*aj ## rx*aj ## sx
 cuss = aj ## sx**2
 coeff(ma2(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma2( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma2( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2 
 coeff(ma2( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma2(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma2( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
#endMacro

#beginMacro xyCoeffOrder2Dim2(coeff,aj)
! Operator xy = ry*rx*urr+(sy*rx+ry*sx)*urs+sy*sx*uss+rxy*ur+sxy*us
 cur = aj ## rxy
 curr = aj ## ry*aj ## rx
 cus = aj ## sxy
 curs = aj ## sy*aj ## rx+aj ## ry*aj ## sx
 cuss = aj ## sy*aj ## sx
 coeff(ma2(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma2( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma2( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2 
 coeff(ma2( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma2(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma2( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
#endMacro

#beginMacro yyCoeffOrder2Dim2(coeff,aj)
! Operator yy = ry^2*urr+2*ry*sy*urs+sy^2*uss+ryy*ur+syy*us
 cur = aj ## ryy
 curr = aj ## ry**2
 cus = aj ## syy
 curs = 2.*aj ## ry*aj ## sy
 cuss = aj ## sy**2
 coeff(ma2(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma2( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma2( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2 
 coeff(ma2( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma2(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma2( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma2( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
#endMacro

#beginMacro rrCoeffOrder2Dim2(coeff,aj)
! Operator rr = urr
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 1./(dr(0))**2 
 coeff(ma2( 0, 0, 0)) = -2./(dr(0))**2 
 coeff(ma2( 1, 0, 0)) = 1./(dr(0))**2 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = 0. 
#endMacro

#beginMacro ssCoeffOrder2Dim2(coeff,aj)
! Operator ss = uss
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 1./(dr(1))**2 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = -2./(dr(1))**2 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 1./(dr(1))**2 
 coeff(ma2( 1, 1, 0)) = 0. 
#endMacro

#beginMacro rrrrCoeffOrder2Dim2(coeff,aj)
! Operator rrrr = urrrr
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = 0. 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = 1./(dr(0))**4 
 coeff(ma2(-1, 0, 0)) = -4./(dr(0))**4 
 coeff(ma2( 0, 0, 0)) = 6./(dr(0))**4 
 coeff(ma2( 1, 0, 0)) = -4./(dr(0))**4 
 coeff(ma2( 2, 0, 0)) = 1./(dr(0))**4 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = 0. 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro ssssCoeffOrder2Dim2(coeff,aj)
! Operator ssss = ussss
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = 1./(dr(1))**4 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = -4./(dr(1))**4 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = 6./(dr(1))**4 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2( 2, 0, 0)) = 0. 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = -4./(dr(1))**4 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = 1./(dr(1))**4 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro r2DissipationCoeffOrder2Dim2(coeff,aj)
! Operator r2Dissipation = urr+uss
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 1./(dr(1))**2 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 1./(dr(0))**2 
 coeff(ma2( 0, 0, 0)) = -2./(dr(0))**2-2./(dr(1))**2 
 coeff(ma2( 1, 0, 0)) = 1./(dr(0))**2 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 1./(dr(1))**2 
 coeff(ma2( 1, 1, 0)) = 0. 
#endMacro

#beginMacro r4DissipationCoeffOrder2Dim2(coeff,aj)
! Operator r4Dissipation = urrrr+ussss
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = 1./(dr(1))**4 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = -4./(dr(1))**4 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = 1./(dr(0))**4 
 coeff(ma2(-1, 0, 0)) = -4./(dr(0))**4 
 coeff(ma2( 0, 0, 0)) = 6./(dr(0))**4+6./(dr(1))**4 
 coeff(ma2( 1, 0, 0)) = -4./(dr(0))**4 
 coeff(ma2( 2, 0, 0)) = 1./(dr(0))**4 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = -4./(dr(1))**4 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = 1./(dr(1))**4 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro xCoeffOrder2Dim2Rectangular(coeff,aj)
! Operator x = 1.*ux
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = -.5000000000/(dx(0)) 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = .5000000000/(dx(0)) 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = 0. 
#endMacro

#beginMacro yCoeffOrder2Dim2Rectangular(coeff,aj)
! Operator y = 1.*uy
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = -.5000000000/(dx(1)) 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = .5000000000/(dx(1)) 
 coeff(ma2( 1, 1, 0)) = 0. 
#endMacro

#beginMacro xxCoeffOrder2Dim2Rectangular(coeff,aj)
! Operator xx = 1.*uxx
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 1./(dx(0))**2 
 coeff(ma2( 0, 0, 0)) = -2./(dx(0))**2 
 coeff(ma2( 1, 0, 0)) = 1./(dx(0))**2 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = 0. 
#endMacro

#beginMacro xyCoeffOrder2Dim2Rectangular(coeff,aj)
! Operator xy = 1.*uxy
 coeff(ma2(-1,-1, 0)) = .2500000000/(dx(0))/(dx(1)) 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = -.2500000000/(dx(0))/(dx(1)) 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = -.2500000000/(dx(0))/(dx(1)) 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = .2500000000/(dx(0))/(dx(1)) 
#endMacro

#beginMacro yyCoeffOrder2Dim2Rectangular(coeff,aj)
! Operator yy = 1.*uyy
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 1./(dx(1))**2 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = -2./(dx(1))**2 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 1./(dx(1))**2 
 coeff(ma2( 1, 1, 0)) = 0. 
#endMacro

#beginMacro laplacianCoeffOrder2Dim2Rectangular(coeff,aj)
! Operator laplacian = 1.*uxx+1.*uyy
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 1./(dx(1))**2 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 1./(dx(0))**2 
 coeff(ma2( 0, 0, 0)) = -2./(dx(0))**2-2./(dx(1))**2 
 coeff(ma2( 1, 0, 0)) = 1./(dx(0))**2 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 1./(dx(1))**2 
 coeff(ma2( 1, 1, 0)) = 0. 
#endMacro


! *** dim=2, orderOfAccuracy = 4 *** 

#beginMacro xCoeffOrder4Dim2(coeff,aj)
! Operator x = 1.*ur
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = 0. 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = .8333333333e-1/(dr(0)) 
 coeff(ma2(-1, 0, 0)) = -.6666666667/(dr(0)) 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = .6666666667/(dr(0)) 
 coeff(ma2( 2, 0, 0)) = -.8333333333e-1/(dr(0)) 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = 0. 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro yCoeffOrder4Dim2(coeff,aj)
! Operator y = 1.*us
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = .8333333333e-1/(dr(1)) 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = -.6666666667/(dr(1)) 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2( 2, 0, 0)) = 0. 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = .6666666667/(dr(1)) 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = -.8333333333e-1/(dr(1)) 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro xxCoeffOrder4Dim2(coeff,aj)
! Operator xx = 1.*urr
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = 0. 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = -.8333333333e-1/(dr(0))**2 
 coeff(ma2(-1, 0, 0)) = 1.333333333/(dr(0))**2 
 coeff(ma2( 0, 0, 0)) = -2.500000000/(dr(0))**2 
 coeff(ma2( 1, 0, 0)) = 1.333333333/(dr(0))**2 
 coeff(ma2( 2, 0, 0)) = -.8333333333e-1/(dr(0))**2 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = 0. 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro xyCoeffOrder4Dim2(coeff,aj)
! Operator xy = 1.*urs
 coeff(ma2(-2,-2, 0)) = .6944444444e-2/(dr(0))/(dr(1)) 
 coeff(ma2(-1,-2, 0)) = -.5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma2( 0,-2, 0)) = 0. 
 coeff(ma2( 1,-2, 0)) = .5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma2( 2,-2, 0)) = -.6944444444e-2/(dr(0))/(dr(1)) 
 coeff(ma2(-2,-1, 0)) = -.5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma2(-1,-1, 0)) = .4444444444/(dr(0))/(dr(1)) 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = -.4444444444/(dr(0))/(dr(1)) 
 coeff(ma2( 2,-1, 0)) = .5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma2(-2, 0, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2( 2, 0, 0)) = 0. 
 coeff(ma2(-2, 1, 0)) = .5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma2(-1, 1, 0)) = -.4444444444/(dr(0))/(dr(1)) 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = .4444444444/(dr(0))/(dr(1)) 
 coeff(ma2( 2, 1, 0)) = -.5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma2(-2, 2, 0)) = -.6944444444e-2/(dr(0))/(dr(1)) 
 coeff(ma2(-1, 2, 0)) = .5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma2( 0, 2, 0)) = 0. 
 coeff(ma2( 1, 2, 0)) = -.5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma2( 2, 2, 0)) = .6944444444e-2/(dr(0))/(dr(1)) 
#endMacro

#beginMacro yyCoeffOrder4Dim2(coeff,aj)
! Operator yy = 1.*uss
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = -.8333333333e-1/(dr(1))**2 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 1.333333333/(dr(1))**2 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = -2.500000000/(dr(1))**2 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2( 2, 0, 0)) = 0. 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 1.333333333/(dr(1))**2 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = -.8333333333e-1/(dr(1))**2 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro laplacianCoeffOrder4Dim2(coeff,aj)
! Operator laplacian = 1.*urr+1.*uss
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = -.8333333333e-1/(dr(1))**2 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 1.333333333/(dr(1))**2 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = -.8333333333e-1/(dr(0))**2 
 coeff(ma2(-1, 0, 0)) = 1.333333333/(dr(0))**2 
 coeff(ma2( 0, 0, 0)) = -2.500000000/(dr(0))**2-2.500000000/(dr(1))**2 
 coeff(ma2( 1, 0, 0)) = 1.333333333/(dr(0))**2 
 coeff(ma2( 2, 0, 0)) = -.8333333333e-1/(dr(0))**2 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 1.333333333/(dr(1))**2 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = -.8333333333e-1/(dr(1))**2 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro xCoeffOrder4Dim2Rectangular(coeff,aj)
! Operator x = 1.*ux
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = 0. 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = .8333333333e-1/(dx(0)) 
 coeff(ma2(-1, 0, 0)) = -.6666666667/(dx(0)) 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = .6666666667/(dx(0)) 
 coeff(ma2( 2, 0, 0)) = -.8333333333e-1/(dx(0)) 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = 0. 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro yCoeffOrder4Dim2Rectangular(coeff,aj)
! Operator y = 1.*uy
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = .8333333333e-1/(dx(1)) 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = -.6666666667/(dx(1)) 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2( 2, 0, 0)) = 0. 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = .6666666667/(dx(1)) 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = -.8333333333e-1/(dx(1)) 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro xxCoeffOrder4Dim2Rectangular(coeff,aj)
! Operator xx = 1.*uxx
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = 0. 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = -.8333333333e-1/(dx(0))**2 
 coeff(ma2(-1, 0, 0)) = 1.333333333/(dx(0))**2 
 coeff(ma2( 0, 0, 0)) = -2.500000000/(dx(0))**2 
 coeff(ma2( 1, 0, 0)) = 1.333333333/(dx(0))**2 
 coeff(ma2( 2, 0, 0)) = -.8333333333e-1/(dx(0))**2 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = 0. 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro xyCoeffOrder4Dim2Rectangular(coeff,aj)
! Operator xy = 1.*uxy
 coeff(ma2(-2,-2, 0)) = .6944444444e-2/(dx(0))/(dx(1)) 
 coeff(ma2(-1,-2, 0)) = -.5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma2( 0,-2, 0)) = 0. 
 coeff(ma2( 1,-2, 0)) = .5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma2( 2,-2, 0)) = -.6944444444e-2/(dx(0))/(dx(1)) 
 coeff(ma2(-2,-1, 0)) = -.5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma2(-1,-1, 0)) = .4444444444/(dx(0))/(dx(1)) 
 coeff(ma2( 0,-1, 0)) = 0. 
 coeff(ma2( 1,-1, 0)) = -.4444444444/(dx(0))/(dx(1)) 
 coeff(ma2( 2,-1, 0)) = .5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma2(-2, 0, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = 0. 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2( 2, 0, 0)) = 0. 
 coeff(ma2(-2, 1, 0)) = .5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma2(-1, 1, 0)) = -.4444444444/(dx(0))/(dx(1)) 
 coeff(ma2( 0, 1, 0)) = 0. 
 coeff(ma2( 1, 1, 0)) = .4444444444/(dx(0))/(dx(1)) 
 coeff(ma2( 2, 1, 0)) = -.5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma2(-2, 2, 0)) = -.6944444444e-2/(dx(0))/(dx(1)) 
 coeff(ma2(-1, 2, 0)) = .5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma2( 0, 2, 0)) = 0. 
 coeff(ma2( 1, 2, 0)) = -.5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma2( 2, 2, 0)) = .6944444444e-2/(dx(0))/(dx(1)) 
#endMacro

#beginMacro yyCoeffOrder4Dim2Rectangular(coeff,aj)
! Operator yy = 1.*uyy
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = -.8333333333e-1/(dx(1))**2 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 1.333333333/(dx(1))**2 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = 0. 
 coeff(ma2(-1, 0, 0)) = 0. 
 coeff(ma2( 0, 0, 0)) = -2.500000000/(dx(1))**2 
 coeff(ma2( 1, 0, 0)) = 0. 
 coeff(ma2( 2, 0, 0)) = 0. 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 1.333333333/(dx(1))**2 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = -.8333333333e-1/(dx(1))**2 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro laplacianCoeffOrder4Dim2Rectangular(coeff,aj)
! Operator laplacian = 1.*uxx+1.*uyy
 coeff(ma2(-2,-2, 0)) = 0. 
 coeff(ma2(-1,-2, 0)) = 0. 
 coeff(ma2( 0,-2, 0)) = -.8333333333e-1/(dx(1))**2 
 coeff(ma2( 1,-2, 0)) = 0. 
 coeff(ma2( 2,-2, 0)) = 0. 
 coeff(ma2(-2,-1, 0)) = 0. 
 coeff(ma2(-1,-1, 0)) = 0. 
 coeff(ma2( 0,-1, 0)) = 1.333333333/(dx(1))**2 
 coeff(ma2( 1,-1, 0)) = 0. 
 coeff(ma2( 2,-1, 0)) = 0. 
 coeff(ma2(-2, 0, 0)) = -.8333333333e-1/(dx(0))**2 
 coeff(ma2(-1, 0, 0)) = 1.333333333/(dx(0))**2 
 coeff(ma2( 0, 0, 0)) = -2.500000000/(dx(0))**2-2.500000000/(dx(1))**2 
 coeff(ma2( 1, 0, 0)) = 1.333333333/(dx(0))**2 
 coeff(ma2( 2, 0, 0)) = -.8333333333e-1/(dx(0))**2 
 coeff(ma2(-2, 1, 0)) = 0. 
 coeff(ma2(-1, 1, 0)) = 0. 
 coeff(ma2( 0, 1, 0)) = 1.333333333/(dx(1))**2 
 coeff(ma2( 1, 1, 0)) = 0. 
 coeff(ma2( 2, 1, 0)) = 0. 
 coeff(ma2(-2, 2, 0)) = 0. 
 coeff(ma2(-1, 2, 0)) = 0. 
 coeff(ma2( 0, 2, 0)) = -.8333333333e-1/(dx(1))**2 
 coeff(ma2( 1, 2, 0)) = 0. 
 coeff(ma2( 2, 2, 0)) = 0. 
#endMacro

#beginMacro identityCoeffOrder2Dim2(coeff,aj)
! Operator identity 
 coeff(ma2(-1,-1, 0)) = 0 
 coeff(ma2( 0,-1, 0)) = 0 
 coeff(ma2( 1,-1, 0)) = 0 
 coeff(ma2(-1, 0, 0)) = 0 
 coeff(ma2( 0, 0, 0)) = 1. 
 coeff(ma2( 1, 0, 0)) = 0 
 coeff(ma2(-1, 1, 0)) = 0 
 coeff(ma2( 0, 1, 0)) = 0 
 coeff(ma2( 1, 1, 0)) = 0 
#endMacro

#beginMacro identityCoeffOrder4Dim2(coeff,aj)
! Operator identity 
 coeff(ma2(-2,-2, 0)) = 0 
 coeff(ma2(-1,-2, 0)) = 0 
 coeff(ma2( 0,-2, 0)) = 0 
 coeff(ma2( 1,-2, 0)) = 0 
 coeff(ma2( 2,-2, 0)) = 0 
 coeff(ma2(-2,-1, 0)) = 0 
 coeff(ma2(-1,-1, 0)) = 0 
 coeff(ma2( 0,-1, 0)) = 0 
 coeff(ma2( 1,-1, 0)) = 0 
 coeff(ma2( 2,-1, 0)) = 0 
 coeff(ma2(-2, 0, 0)) = 0 
 coeff(ma2(-1, 0, 0)) = 0 
 coeff(ma2( 0, 0, 0)) = 1. 
 coeff(ma2( 1, 0, 0)) = 0 
 coeff(ma2( 2, 0, 0)) = 0 
 coeff(ma2(-2, 1, 0)) = 0 
 coeff(ma2(-1, 1, 0)) = 0 
 coeff(ma2( 0, 1, 0)) = 0 
 coeff(ma2( 1, 1, 0)) = 0 
 coeff(ma2( 2, 1, 0)) = 0 
 coeff(ma2(-2, 2, 0)) = 0 
 coeff(ma2(-1, 2, 0)) = 0 
 coeff(ma2( 0, 2, 0)) = 0 
 coeff(ma2( 1, 2, 0)) = 0 
 coeff(ma2( 2, 2, 0)) = 0 
#endMacro

#beginMacro identityCoeffOrder6Dim2(coeff,aj)
! Operator identity 
 coeff(ma2(-3,-3, 0)) = 0 
 coeff(ma2(-2,-3, 0)) = 0 
 coeff(ma2(-1,-3, 0)) = 0 
 coeff(ma2( 0,-3, 0)) = 0 
 coeff(ma2( 1,-3, 0)) = 0 
 coeff(ma2( 2,-3, 0)) = 0 
 coeff(ma2( 3,-3, 0)) = 0 
 coeff(ma2(-3,-2, 0)) = 0 
 coeff(ma2(-2,-2, 0)) = 0 
 coeff(ma2(-1,-2, 0)) = 0 
 coeff(ma2( 0,-2, 0)) = 0 
 coeff(ma2( 1,-2, 0)) = 0 
 coeff(ma2( 2,-2, 0)) = 0 
 coeff(ma2( 3,-2, 0)) = 0 
 coeff(ma2(-3,-1, 0)) = 0 
 coeff(ma2(-2,-1, 0)) = 0 
 coeff(ma2(-1,-1, 0)) = 0 
 coeff(ma2( 0,-1, 0)) = 0 
 coeff(ma2( 1,-1, 0)) = 0 
 coeff(ma2( 2,-1, 0)) = 0 
 coeff(ma2( 3,-1, 0)) = 0 
 coeff(ma2(-3, 0, 0)) = 0 
 coeff(ma2(-2, 0, 0)) = 0 
 coeff(ma2(-1, 0, 0)) = 0 
 coeff(ma2( 0, 0, 0)) = 1. 
 coeff(ma2( 1, 0, 0)) = 0 
 coeff(ma2( 2, 0, 0)) = 0 
 coeff(ma2( 3, 0, 0)) = 0 
 coeff(ma2(-3, 1, 0)) = 0 
 coeff(ma2(-2, 1, 0)) = 0 
 coeff(ma2(-1, 1, 0)) = 0 
 coeff(ma2( 0, 1, 0)) = 0 
 coeff(ma2( 1, 1, 0)) = 0 
 coeff(ma2( 2, 1, 0)) = 0 
 coeff(ma2( 3, 1, 0)) = 0 
 coeff(ma2(-3, 2, 0)) = 0 
 coeff(ma2(-2, 2, 0)) = 0 
 coeff(ma2(-1, 2, 0)) = 0 
 coeff(ma2( 0, 2, 0)) = 0 
 coeff(ma2( 1, 2, 0)) = 0 
 coeff(ma2( 2, 2, 0)) = 0 
 coeff(ma2( 3, 2, 0)) = 0 
 coeff(ma2(-3, 3, 0)) = 0 
 coeff(ma2(-2, 3, 0)) = 0 
 coeff(ma2(-1, 3, 0)) = 0 
 coeff(ma2( 0, 3, 0)) = 0 
 coeff(ma2( 1, 3, 0)) = 0 
 coeff(ma2( 2, 3, 0)) = 0 
 coeff(ma2( 3, 3, 0)) = 0 
#endMacro


! *** dim=3, orderOfAccuracy = 2 *** 

#beginMacro xCoeffOrder2Dim3(coeff,aj)
! Operator x = rx*ur+sx*us+tx*ut
 cur = aj ## rx
 cus = aj ## sx
 cut = aj ## tx
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 0 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 0 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2)) 
 coeff(ma3( 1, 0,-1)) = 0 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = 0 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 0 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1)) 
 coeff(ma3( 1,-1, 0)) = 0 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0)) 
 coeff(ma3( 0, 0, 0)) = 0 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0)) 
 coeff(ma3(-1, 1, 0)) = 0 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1)) 
 coeff(ma3( 1, 1, 0)) = 0 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = 0 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = 0 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2)) 
 coeff(ma3( 1, 0, 1)) = 0 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 0 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro yCoeffOrder2Dim3(coeff,aj)
! Operator y = ry*ur+sy*us+ty*ut
 cur = aj ## ry
 cus = aj ## sy
 cut = aj ## ty
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 0 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 0 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2)) 
 coeff(ma3( 1, 0,-1)) = 0 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = 0 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 0 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1)) 
 coeff(ma3( 1,-1, 0)) = 0 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0)) 
 coeff(ma3( 0, 0, 0)) = 0 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0)) 
 coeff(ma3(-1, 1, 0)) = 0 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1)) 
 coeff(ma3( 1, 1, 0)) = 0 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = 0 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = 0 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2)) 
 coeff(ma3( 1, 0, 1)) = 0 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 0 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro zCoeffOrder2Dim3(coeff,aj)
! Operator z = rz*ur+sz*us+tz*ut
 cur = aj ## rz
 cus = aj ## sz
 cut = aj ## tz
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 0 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 0 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2)) 
 coeff(ma3( 1, 0,-1)) = 0 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = 0 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 0 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1)) 
 coeff(ma3( 1,-1, 0)) = 0 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0)) 
 coeff(ma3( 0, 0, 0)) = 0 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0)) 
 coeff(ma3(-1, 1, 0)) = 0 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1)) 
 coeff(ma3( 1, 1, 0)) = 0 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = 0 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = 0 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2)) 
 coeff(ma3( 1, 0, 1)) = 0 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 0 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro laplacianCoeffOrder2Dim3(coeff,aj)
! Operator laplacian = 2*ry*ty*urt+2*rx*sx*urs+2*rz*tz*urt+rx^2*urr+rxx*ur+sx^2*uss+sxx*us+ry^2*urr+ryy*ur+sy^2*uss+syy*us+2*rz*sz*urs+2*ry*sy*urs+2*sz*tz*ust+2*rx*tx*urt+2*sx*tx*ust+2*sy*ty*ust+tx^2*utt+txx*ut+ty^2*utt+tyy*ut+rz^2*urr+tz^2*utt+sz^2*uss+rzz*ur+szz*us+tzz*ut
 cur = aj ## rxx+aj ## ryy+aj ## rzz
 curr = aj ## rx**2+aj ## ry**2+aj ## rz**2
 cus = aj ## sxx+aj ## syy+aj ## szz
 curs = 2.*aj ## rx*aj ## sx+2.*aj ## rz*aj ## sz+2.*aj ## ry*aj ## sy
 cuss = aj ## sx**2+aj ## sy**2+aj ## sz**2
 cut = aj ## txx+aj ## tyy+aj ## tzz
 curt = 2.*aj ## ry*aj ## ty+2.*aj ## rz*aj ## tz+2.*aj ## rx*aj ## tx
 cust = 2.*aj ## sz*aj ## tz+2.*aj ## sx*aj ## tx+2.*aj ## sy*aj ## ty
 cutt = aj ## tx**2+aj ## ty**2+aj ## tz**2
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2-2.*cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro xxCoeffOrder2Dim3(coeff,aj)
! Operator xx = rx^2*urr+2*rx*sx*urs+sx^2*uss+2*rx*tx*urt+2*sx*tx*ust+tx^2*utt+rxx*ur+sxx*us+txx*ut
 cur = aj ## rxx
 curr = aj ## rx**2
 cus = aj ## sxx
 curs = 2.*aj ## rx*aj ## sx
 cuss = aj ## sx**2
 cut = aj ## txx
 curt = 2.*aj ## rx*aj ## tx
 cust = 2.*aj ## sx*aj ## tx
 cutt = aj ## tx**2
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2-2.*cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro xyCoeffOrder2Dim3(coeff,aj)
! Operator xy = ry*rx*urr+(sy*rx+ry*sx)*urs+sy*sx*uss+(ry*tx+ty*rx)*urt+(ty*sx+sy*tx)*ust+ty*tx*utt+rxy*ur+sxy*us+txy*ut
 cur = aj ## rxy
 curr = aj ## ry*aj ## rx
 cus = aj ## sxy
 curs = aj ## sy*aj ## rx+aj ## ry*aj ## sx
 cuss = aj ## sy*aj ## sx
 cut = aj ## txy
 curt = aj ## ry*aj ## tx+aj ## ty*aj ## rx
 cust = aj ## ty*aj ## sx+aj ## sy*aj ## tx
 cutt = aj ## ty*aj ## tx
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2-2.*cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro yyCoeffOrder2Dim3(coeff,aj)
! Operator yy = ry^2*urr+2*ry*sy*urs+sy^2*uss+2*ry*ty*urt+2*sy*ty*ust+ty^2*utt+ryy*ur+syy*us+tyy*ut
 cur = aj ## ryy
 curr = aj ## ry**2
 cus = aj ## syy
 curs = 2.*aj ## ry*aj ## sy
 cuss = aj ## sy**2
 cut = aj ## tyy
 curt = 2.*aj ## ry*aj ## ty
 cust = 2.*aj ## sy*aj ## ty
 cutt = aj ## ty**2
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2-2.*cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro xzCoeffOrder2Dim3(coeff,aj)
! Operator xz = rz*rx*urr+(sz*rx+rz*sx)*urs+sz*sx*uss+(rz*tx+tz*rx)*urt+(tz*sx+sz*tx)*ust+tz*tx*utt+rxz*ur+sxz*us+txz*ut
 cur = aj ## rxz
 curr = aj ## rz*aj ## rx
 cus = aj ## sxz
 curs = aj ## sz*aj ## rx+aj ## rz*aj ## sx
 cuss = aj ## sz*aj ## sx
 cut = aj ## txz
 curt = aj ## rz*aj ## tx+aj ## tz*aj ## rx
 cust = aj ## tz*aj ## sx+aj ## sz*aj ## tx
 cutt = aj ## tz*aj ## tx
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2-2.*cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro yzCoeffOrder2Dim3(coeff,aj)
! Operator yz = rz*ry*urr+(sz*ry+rz*sy)*urs+sz*sy*uss+(rz*ty+tz*ry)*urt+(tz*sy+sz*ty)*ust+tz*ty*utt+ryz*ur+syz*us+tyz*ut
 cur = aj ## ryz
 curr = aj ## rz*aj ## ry
 cus = aj ## syz
 curs = aj ## sz*aj ## ry+aj ## rz*aj ## sy
 cuss = aj ## sz*aj ## sy
 cut = aj ## tyz
 curt = aj ## rz*aj ## ty+aj ## tz*aj ## ry
 cust = aj ## tz*aj ## sy+aj ## sz*aj ## ty
 cutt = aj ## tz*aj ## ty
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2-2.*cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro zzCoeffOrder2Dim3(coeff,aj)
! Operator zz = rz^2*urr+2*rz*sz*urs+sz^2*uss+2*rz*tz*urt+2*sz*tz*ust+tz^2*utt+rzz*ur+szz*us+tzz*ut
 cur = aj ## rzz
 curr = aj ## rz**2
 cus = aj ## szz
 curs = 2.*aj ## rz*aj ## sz
 cuss = aj ## sz**2
 cut = aj ## tzz
 curt = 2.*aj ## rz*aj ## tz
 cust = 2.*aj ## sz*aj ## tz
 cutt = aj ## tz**2
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-1)) = -1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-1, 0)) = -1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 0, 0)) = -1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.*curr/(dr(0))**2-2.*cuss/(dr(1))**2-2.*cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1/2.*cur/(dr(0))+curr/(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = -1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 1, 0)) = 1/2.*cus/(dr(1))+cuss/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 1/4.*curs/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = -1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = -1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 1)) = 1/2.*cut/(dr(2))+cutt/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 1/4.*curt/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 1/4.*cust/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro rrCoeffOrder2Dim3(coeff,aj)
! Operator rr = urr
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 1./(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2./(dr(0))**2 
 coeff(ma3( 1, 0, 0)) = 1./(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro ssCoeffOrder2Dim3(coeff,aj)
! Operator ss = uss
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 1./(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = -2./(dr(1))**2 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 1./(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro rrrrCoeffOrder2Dim3(coeff,aj)
! Operator rrrr = urrrr
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 1./(dr(0))**4 
 coeff(ma3(-1, 0, 0)) = -4./(dr(0))**4 
 coeff(ma3( 0, 0, 0)) = 6./(dr(0))**4 
 coeff(ma3( 1, 0, 0)) = -4./(dr(0))**4 
 coeff(ma3( 2, 0, 0)) = 1./(dr(0))**4 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro ssssCoeffOrder2Dim3(coeff,aj)
! Operator ssss = ussss
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 1./(dr(1))**4 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = -4./(dr(1))**4 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 6./(dr(1))**4 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = -4./(dr(1))**4 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 1./(dr(1))**4 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro r2DissipationCoeffOrder2Dim3(coeff,aj)
! Operator r2Dissipation = urr+uss+utt
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 1./(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 1./(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 1./(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2./(dr(0))**2-2./(dr(1))**2-2./(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1./(dr(0))**2 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 1./(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 1./(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro r4DissipationCoeffOrder2Dim3(coeff,aj)
! Operator r4Dissipation = urrrr+ussss+utttt
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 1./(dr(2))**4 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = -4./(dr(2))**4 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 1./(dr(1))**4 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = -4./(dr(1))**4 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 1./(dr(0))**4 
 coeff(ma3(-1, 0, 0)) = -4./(dr(0))**4 
 coeff(ma3( 0, 0, 0)) = 6./(dr(0))**4+6./(dr(1))**4+6./(dr(2))**4 
 coeff(ma3( 1, 0, 0)) = -4./(dr(0))**4 
 coeff(ma3( 2, 0, 0)) = 1./(dr(0))**4 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = -4./(dr(1))**4 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 1./(dr(1))**4 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = -4./(dr(2))**4 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 1./(dr(2))**4 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro ttCoeffOrder2Dim3(coeff,aj)
! Operator tt = utt
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 1./(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = -2./(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 1./(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro ttttCoeffOrder2Dim3(coeff,aj)
! Operator tttt = utttt
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 1./(dr(2))**4 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = -4./(dr(2))**4 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 6./(dr(2))**4 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = -4./(dr(2))**4 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 1./(dr(2))**4 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro xCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator x = 1.*ux
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = -.5000000000/(dx(0)) 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = .5000000000/(dx(0)) 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro yCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator y = 1.*uy
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = -.5000000000/(dx(1)) 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = .5000000000/(dx(1)) 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro xxCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator xx = 1.*uxx
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 1./(dx(0))**2 
 coeff(ma3( 0, 0, 0)) = -2./(dx(0))**2 
 coeff(ma3( 1, 0, 0)) = 1./(dx(0))**2 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro xyCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator xy = 1.*uxy
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = .2500000000/(dx(0))/(dx(1)) 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = -.2500000000/(dx(0))/(dx(1)) 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = -.2500000000/(dx(0))/(dx(1)) 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = .2500000000/(dx(0))/(dx(1)) 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro yyCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator yy = 1.*uyy
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 1./(dx(1))**2 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = -2./(dx(1))**2 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 1./(dx(1))**2 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro zCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator z = 1.*uz
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = -.5000000000/(dx(2)) 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = .5000000000/(dx(2)) 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro xzCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator xz = 1.*uxz
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = .2500000000/(dx(0))/(dx(2)) 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = -.2500000000/(dx(0))/(dx(2)) 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = -.2500000000/(dx(0))/(dx(2)) 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = .2500000000/(dx(0))/(dx(2)) 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro yzCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator yz = 1.*uyz
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = .2500000000/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = -.2500000000/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = -.2500000000/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = .2500000000/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro zzCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator zz = 1.*uzz
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 1./(dx(2))**2 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = -2./(dx(2))**2 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 1./(dx(2))**2 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro

#beginMacro laplacianCoeffOrder2Dim3Rectangular(coeff,aj)
! Operator laplacian = 1.*uxx+1.*uyy+1.*uzz
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 1./(dx(2))**2 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 1./(dx(1))**2 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 1./(dx(0))**2 
 coeff(ma3( 0, 0, 0)) = -2./(dx(0))**2-2./(dx(1))**2-2./(dx(2))**2 
 coeff(ma3( 1, 0, 0)) = 1./(dx(0))**2 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 1./(dx(1))**2 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 1./(dx(2))**2 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
#endMacro


! *** dim=3, orderOfAccuracy = 4 *** 

#beginMacro xCoeffOrder4Dim3(coeff,aj)
! Operator x = 1.*ur
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = .8333333333e-1/(dr(0)) 
 coeff(ma3(-1, 0, 0)) = -.6666666667/(dr(0)) 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = .6666666667/(dr(0)) 
 coeff(ma3( 2, 0, 0)) = -.8333333333e-1/(dr(0)) 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro yCoeffOrder4Dim3(coeff,aj)
! Operator y = 1.*us
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = .8333333333e-1/(dr(1)) 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = -.6666666667/(dr(1)) 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = .6666666667/(dr(1)) 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = -.8333333333e-1/(dr(1)) 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro xxCoeffOrder4Dim3(coeff,aj)
! Operator xx = 1.*urr
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = -.8333333333e-1/(dr(0))**2 
 coeff(ma3(-1, 0, 0)) = 1.333333333/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.500000000/(dr(0))**2 
 coeff(ma3( 1, 0, 0)) = 1.333333333/(dr(0))**2 
 coeff(ma3( 2, 0, 0)) = -.8333333333e-1/(dr(0))**2 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro xyCoeffOrder4Dim3(coeff,aj)
! Operator xy = 1.*urs
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = .6944444444e-2/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-2, 0)) = -.5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = .5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma3( 2,-2, 0)) = -.6944444444e-2/(dr(0))/(dr(1)) 
 coeff(ma3(-2,-1, 0)) = -.5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma3(-1,-1, 0)) = .4444444444/(dr(0))/(dr(1)) 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = -.4444444444/(dr(0))/(dr(1)) 
 coeff(ma3( 2,-1, 0)) = .5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = .5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 1, 0)) = -.4444444444/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = .4444444444/(dr(0))/(dr(1)) 
 coeff(ma3( 2, 1, 0)) = -.5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma3(-2, 2, 0)) = -.6944444444e-2/(dr(0))/(dr(1)) 
 coeff(ma3(-1, 2, 0)) = .5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = -.5555555556e-1/(dr(0))/(dr(1)) 
 coeff(ma3( 2, 2, 0)) = .6944444444e-2/(dr(0))/(dr(1)) 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro yyCoeffOrder4Dim3(coeff,aj)
! Operator yy = 1.*uss
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = -.8333333333e-1/(dr(1))**2 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 1.333333333/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = -2.500000000/(dr(1))**2 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 1.333333333/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = -.8333333333e-1/(dr(1))**2 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro zCoeffOrder4Dim3(coeff,aj)
! Operator z = 1.*ut
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = .8333333333e-1/(dr(2)) 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = -.6666666667/(dr(2)) 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = .6666666667/(dr(2)) 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = -.8333333333e-1/(dr(2)) 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro xzCoeffOrder4Dim3(coeff,aj)
! Operator xz = 1.*urt
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = .6944444444e-2/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 0,-2)) = -.5555555556e-1/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = .5555555556e-1/(dr(0))/(dr(2)) 
 coeff(ma3( 2, 0,-2)) = -.6944444444e-2/(dr(0))/(dr(2)) 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = -.5555555556e-1/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 0,-1)) = .4444444444/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = -.4444444444/(dr(0))/(dr(2)) 
 coeff(ma3( 2, 0,-1)) = .5555555556e-1/(dr(0))/(dr(2)) 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = .5555555556e-1/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 0, 1)) = -.4444444444/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = .4444444444/(dr(0))/(dr(2)) 
 coeff(ma3( 2, 0, 1)) = -.5555555556e-1/(dr(0))/(dr(2)) 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = -.6944444444e-2/(dr(0))/(dr(2)) 
 coeff(ma3(-1, 0, 2)) = .5555555556e-1/(dr(0))/(dr(2)) 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = -.5555555556e-1/(dr(0))/(dr(2)) 
 coeff(ma3( 2, 0, 2)) = .6944444444e-2/(dr(0))/(dr(2)) 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro yzCoeffOrder4Dim3(coeff,aj)
! Operator yz = 1.*ust
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = .6944444444e-2/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = -.5555555556e-1/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = .5555555556e-1/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = -.6944444444e-2/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = -.5555555556e-1/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = .4444444444/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = -.4444444444/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = .5555555556e-1/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = .5555555556e-1/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = -.4444444444/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = .4444444444/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = -.5555555556e-1/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = -.6944444444e-2/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = .5555555556e-1/(dr(1))/(dr(2)) 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = -.5555555556e-1/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = .6944444444e-2/(dr(1))/(dr(2)) 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro zzCoeffOrder4Dim3(coeff,aj)
! Operator zz = 1.*utt
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = -.8333333333e-1/(dr(2))**2 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 1.333333333/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = -2.500000000/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 1.333333333/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = -.8333333333e-1/(dr(2))**2 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro laplacianCoeffOrder4Dim3(coeff,aj)
! Operator laplacian = 1.*urr+1.*uss+1.*utt
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = -.8333333333e-1/(dr(2))**2 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 1.333333333/(dr(2))**2 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = -.8333333333e-1/(dr(1))**2 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 1.333333333/(dr(1))**2 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = -.8333333333e-1/(dr(0))**2 
 coeff(ma3(-1, 0, 0)) = 1.333333333/(dr(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.500000000/(dr(0))**2-2.500000000/(dr(1))**2-2.500000000/(dr(2))**2 
 coeff(ma3( 1, 0, 0)) = 1.333333333/(dr(0))**2 
 coeff(ma3( 2, 0, 0)) = -.8333333333e-1/(dr(0))**2 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 1.333333333/(dr(1))**2 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = -.8333333333e-1/(dr(1))**2 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 1.333333333/(dr(2))**2 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = -.8333333333e-1/(dr(2))**2 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro xCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator x = 1.*ux
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = .8333333333e-1/(dx(0)) 
 coeff(ma3(-1, 0, 0)) = -.6666666667/(dx(0)) 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = .6666666667/(dx(0)) 
 coeff(ma3( 2, 0, 0)) = -.8333333333e-1/(dx(0)) 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro yCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator y = 1.*uy
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = .8333333333e-1/(dx(1)) 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = -.6666666667/(dx(1)) 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = .6666666667/(dx(1)) 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = -.8333333333e-1/(dx(1)) 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro xxCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator xx = 1.*uxx
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = -.8333333333e-1/(dx(0))**2 
 coeff(ma3(-1, 0, 0)) = 1.333333333/(dx(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.500000000/(dx(0))**2 
 coeff(ma3( 1, 0, 0)) = 1.333333333/(dx(0))**2 
 coeff(ma3( 2, 0, 0)) = -.8333333333e-1/(dx(0))**2 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro xyCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator xy = 1.*uxy
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = .6944444444e-2/(dx(0))/(dx(1)) 
 coeff(ma3(-1,-2, 0)) = -.5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = .5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma3( 2,-2, 0)) = -.6944444444e-2/(dx(0))/(dx(1)) 
 coeff(ma3(-2,-1, 0)) = -.5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma3(-1,-1, 0)) = .4444444444/(dx(0))/(dx(1)) 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = -.4444444444/(dx(0))/(dx(1)) 
 coeff(ma3( 2,-1, 0)) = .5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = .5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma3(-1, 1, 0)) = -.4444444444/(dx(0))/(dx(1)) 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = .4444444444/(dx(0))/(dx(1)) 
 coeff(ma3( 2, 1, 0)) = -.5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma3(-2, 2, 0)) = -.6944444444e-2/(dx(0))/(dx(1)) 
 coeff(ma3(-1, 2, 0)) = .5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = -.5555555556e-1/(dx(0))/(dx(1)) 
 coeff(ma3( 2, 2, 0)) = .6944444444e-2/(dx(0))/(dx(1)) 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro yyCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator yy = 1.*uyy
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = -.8333333333e-1/(dx(1))**2 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 1.333333333/(dx(1))**2 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = -2.500000000/(dx(1))**2 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 1.333333333/(dx(1))**2 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = -.8333333333e-1/(dx(1))**2 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro zCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator z = 1.*uz
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = .8333333333e-1/(dx(2)) 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = -.6666666667/(dx(2)) 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = .6666666667/(dx(2)) 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = -.8333333333e-1/(dx(2)) 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro xzCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator xz = 1.*uxz
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = .6944444444e-2/(dx(0))/(dx(2)) 
 coeff(ma3(-1, 0,-2)) = -.5555555556e-1/(dx(0))/(dx(2)) 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = .5555555556e-1/(dx(0))/(dx(2)) 
 coeff(ma3( 2, 0,-2)) = -.6944444444e-2/(dx(0))/(dx(2)) 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = -.5555555556e-1/(dx(0))/(dx(2)) 
 coeff(ma3(-1, 0,-1)) = .4444444444/(dx(0))/(dx(2)) 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = -.4444444444/(dx(0))/(dx(2)) 
 coeff(ma3( 2, 0,-1)) = .5555555556e-1/(dx(0))/(dx(2)) 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = .5555555556e-1/(dx(0))/(dx(2)) 
 coeff(ma3(-1, 0, 1)) = -.4444444444/(dx(0))/(dx(2)) 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = .4444444444/(dx(0))/(dx(2)) 
 coeff(ma3( 2, 0, 1)) = -.5555555556e-1/(dx(0))/(dx(2)) 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = -.6944444444e-2/(dx(0))/(dx(2)) 
 coeff(ma3(-1, 0, 2)) = .5555555556e-1/(dx(0))/(dx(2)) 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = -.5555555556e-1/(dx(0))/(dx(2)) 
 coeff(ma3( 2, 0, 2)) = .6944444444e-2/(dx(0))/(dx(2)) 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro yzCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator yz = 1.*uyz
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = .6944444444e-2/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = -.5555555556e-1/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = 0. 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = .5555555556e-1/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = -.6944444444e-2/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = -.5555555556e-1/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = .4444444444/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 0. 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = -.4444444444/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = .5555555556e-1/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = 0. 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = .5555555556e-1/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = -.4444444444/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 0. 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = .4444444444/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = -.5555555556e-1/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = -.6944444444e-2/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = .5555555556e-1/(dx(1))/(dx(2)) 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = 0. 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = -.5555555556e-1/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = .6944444444e-2/(dx(1))/(dx(2)) 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro zzCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator zz = 1.*uzz
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = -.8333333333e-1/(dx(2))**2 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 1.333333333/(dx(2))**2 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = 0. 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 0. 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = 0. 
 coeff(ma3(-1, 0, 0)) = 0. 
 coeff(ma3( 0, 0, 0)) = -2.500000000/(dx(2))**2 
 coeff(ma3( 1, 0, 0)) = 0. 
 coeff(ma3( 2, 0, 0)) = 0. 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 0. 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = 0. 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 1.333333333/(dx(2))**2 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = -.8333333333e-1/(dx(2))**2 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro laplacianCoeffOrder4Dim3Rectangular(coeff,aj)
! Operator laplacian = 1.*uxx+1.*uyy+1.*uzz
 coeff(ma3(-2,-2,-2)) = 0. 
 coeff(ma3(-1,-2,-2)) = 0. 
 coeff(ma3( 0,-2,-2)) = 0. 
 coeff(ma3( 1,-2,-2)) = 0. 
 coeff(ma3( 2,-2,-2)) = 0. 
 coeff(ma3(-2,-1,-2)) = 0. 
 coeff(ma3(-1,-1,-2)) = 0. 
 coeff(ma3( 0,-1,-2)) = 0. 
 coeff(ma3( 1,-1,-2)) = 0. 
 coeff(ma3( 2,-1,-2)) = 0. 
 coeff(ma3(-2, 0,-2)) = 0. 
 coeff(ma3(-1, 0,-2)) = 0. 
 coeff(ma3( 0, 0,-2)) = -.8333333333e-1/(dx(2))**2 
 coeff(ma3( 1, 0,-2)) = 0. 
 coeff(ma3( 2, 0,-2)) = 0. 
 coeff(ma3(-2, 1,-2)) = 0. 
 coeff(ma3(-1, 1,-2)) = 0. 
 coeff(ma3( 0, 1,-2)) = 0. 
 coeff(ma3( 1, 1,-2)) = 0. 
 coeff(ma3( 2, 1,-2)) = 0. 
 coeff(ma3(-2, 2,-2)) = 0. 
 coeff(ma3(-1, 2,-2)) = 0. 
 coeff(ma3( 0, 2,-2)) = 0. 
 coeff(ma3( 1, 2,-2)) = 0. 
 coeff(ma3( 2, 2,-2)) = 0. 
 coeff(ma3(-2,-2,-1)) = 0. 
 coeff(ma3(-1,-2,-1)) = 0. 
 coeff(ma3( 0,-2,-1)) = 0. 
 coeff(ma3( 1,-2,-1)) = 0. 
 coeff(ma3( 2,-2,-1)) = 0. 
 coeff(ma3(-2,-1,-1)) = 0. 
 coeff(ma3(-1,-1,-1)) = 0. 
 coeff(ma3( 0,-1,-1)) = 0. 
 coeff(ma3( 1,-1,-1)) = 0. 
 coeff(ma3( 2,-1,-1)) = 0. 
 coeff(ma3(-2, 0,-1)) = 0. 
 coeff(ma3(-1, 0,-1)) = 0. 
 coeff(ma3( 0, 0,-1)) = 1.333333333/(dx(2))**2 
 coeff(ma3( 1, 0,-1)) = 0. 
 coeff(ma3( 2, 0,-1)) = 0. 
 coeff(ma3(-2, 1,-1)) = 0. 
 coeff(ma3(-1, 1,-1)) = 0. 
 coeff(ma3( 0, 1,-1)) = 0. 
 coeff(ma3( 1, 1,-1)) = 0. 
 coeff(ma3( 2, 1,-1)) = 0. 
 coeff(ma3(-2, 2,-1)) = 0. 
 coeff(ma3(-1, 2,-1)) = 0. 
 coeff(ma3( 0, 2,-1)) = 0. 
 coeff(ma3( 1, 2,-1)) = 0. 
 coeff(ma3( 2, 2,-1)) = 0. 
 coeff(ma3(-2,-2, 0)) = 0. 
 coeff(ma3(-1,-2, 0)) = 0. 
 coeff(ma3( 0,-2, 0)) = -.8333333333e-1/(dx(1))**2 
 coeff(ma3( 1,-2, 0)) = 0. 
 coeff(ma3( 2,-2, 0)) = 0. 
 coeff(ma3(-2,-1, 0)) = 0. 
 coeff(ma3(-1,-1, 0)) = 0. 
 coeff(ma3( 0,-1, 0)) = 1.333333333/(dx(1))**2 
 coeff(ma3( 1,-1, 0)) = 0. 
 coeff(ma3( 2,-1, 0)) = 0. 
 coeff(ma3(-2, 0, 0)) = -.8333333333e-1/(dx(0))**2 
 coeff(ma3(-1, 0, 0)) = 1.333333333/(dx(0))**2 
 coeff(ma3( 0, 0, 0)) = -2.500000000/(dx(0))**2-2.500000000/(dx(1))**2-2.500000000/(dx(2))**2 
 coeff(ma3( 1, 0, 0)) = 1.333333333/(dx(0))**2 
 coeff(ma3( 2, 0, 0)) = -.8333333333e-1/(dx(0))**2 
 coeff(ma3(-2, 1, 0)) = 0. 
 coeff(ma3(-1, 1, 0)) = 0. 
 coeff(ma3( 0, 1, 0)) = 1.333333333/(dx(1))**2 
 coeff(ma3( 1, 1, 0)) = 0. 
 coeff(ma3( 2, 1, 0)) = 0. 
 coeff(ma3(-2, 2, 0)) = 0. 
 coeff(ma3(-1, 2, 0)) = 0. 
 coeff(ma3( 0, 2, 0)) = -.8333333333e-1/(dx(1))**2 
 coeff(ma3( 1, 2, 0)) = 0. 
 coeff(ma3( 2, 2, 0)) = 0. 
 coeff(ma3(-2,-2, 1)) = 0. 
 coeff(ma3(-1,-2, 1)) = 0. 
 coeff(ma3( 0,-2, 1)) = 0. 
 coeff(ma3( 1,-2, 1)) = 0. 
 coeff(ma3( 2,-2, 1)) = 0. 
 coeff(ma3(-2,-1, 1)) = 0. 
 coeff(ma3(-1,-1, 1)) = 0. 
 coeff(ma3( 0,-1, 1)) = 0. 
 coeff(ma3( 1,-1, 1)) = 0. 
 coeff(ma3( 2,-1, 1)) = 0. 
 coeff(ma3(-2, 0, 1)) = 0. 
 coeff(ma3(-1, 0, 1)) = 0. 
 coeff(ma3( 0, 0, 1)) = 1.333333333/(dx(2))**2 
 coeff(ma3( 1, 0, 1)) = 0. 
 coeff(ma3( 2, 0, 1)) = 0. 
 coeff(ma3(-2, 1, 1)) = 0. 
 coeff(ma3(-1, 1, 1)) = 0. 
 coeff(ma3( 0, 1, 1)) = 0. 
 coeff(ma3( 1, 1, 1)) = 0. 
 coeff(ma3( 2, 1, 1)) = 0. 
 coeff(ma3(-2, 2, 1)) = 0. 
 coeff(ma3(-1, 2, 1)) = 0. 
 coeff(ma3( 0, 2, 1)) = 0. 
 coeff(ma3( 1, 2, 1)) = 0. 
 coeff(ma3( 2, 2, 1)) = 0. 
 coeff(ma3(-2,-2, 2)) = 0. 
 coeff(ma3(-1,-2, 2)) = 0. 
 coeff(ma3( 0,-2, 2)) = 0. 
 coeff(ma3( 1,-2, 2)) = 0. 
 coeff(ma3( 2,-2, 2)) = 0. 
 coeff(ma3(-2,-1, 2)) = 0. 
 coeff(ma3(-1,-1, 2)) = 0. 
 coeff(ma3( 0,-1, 2)) = 0. 
 coeff(ma3( 1,-1, 2)) = 0. 
 coeff(ma3( 2,-1, 2)) = 0. 
 coeff(ma3(-2, 0, 2)) = 0. 
 coeff(ma3(-1, 0, 2)) = 0. 
 coeff(ma3( 0, 0, 2)) = -.8333333333e-1/(dx(2))**2 
 coeff(ma3( 1, 0, 2)) = 0. 
 coeff(ma3( 2, 0, 2)) = 0. 
 coeff(ma3(-2, 1, 2)) = 0. 
 coeff(ma3(-1, 1, 2)) = 0. 
 coeff(ma3( 0, 1, 2)) = 0. 
 coeff(ma3( 1, 1, 2)) = 0. 
 coeff(ma3( 2, 1, 2)) = 0. 
 coeff(ma3(-2, 2, 2)) = 0. 
 coeff(ma3(-1, 2, 2)) = 0. 
 coeff(ma3( 0, 2, 2)) = 0. 
 coeff(ma3( 1, 2, 2)) = 0. 
 coeff(ma3( 2, 2, 2)) = 0. 
#endMacro

#beginMacro identityCoeffOrder2Dim3(coeff,aj)
! Operator identity 
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 0 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 0 
 coeff(ma3( 0, 0,-1)) = 0 
 coeff(ma3( 1, 0,-1)) = 0 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = 0 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3(-1,-1, 0)) = 0 
 coeff(ma3( 0,-1, 0)) = 0 
 coeff(ma3( 1,-1, 0)) = 0 
 coeff(ma3(-1, 0, 0)) = 0 
 coeff(ma3( 0, 0, 0)) = 1. 
 coeff(ma3( 1, 0, 0)) = 0 
 coeff(ma3(-1, 1, 0)) = 0 
 coeff(ma3( 0, 1, 0)) = 0 
 coeff(ma3( 1, 1, 0)) = 0 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = 0 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = 0 
 coeff(ma3( 0, 0, 1)) = 0 
 coeff(ma3( 1, 0, 1)) = 0 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 0 
 coeff(ma3( 1, 1, 1)) = 0 
#endMacro

#beginMacro identityCoeffOrder4Dim3(coeff,aj)
! Operator identity 
 coeff(ma3(-2,-2,-2)) = 0 
 coeff(ma3(-1,-2,-2)) = 0 
 coeff(ma3( 0,-2,-2)) = 0 
 coeff(ma3( 1,-2,-2)) = 0 
 coeff(ma3( 2,-2,-2)) = 0 
 coeff(ma3(-2,-1,-2)) = 0 
 coeff(ma3(-1,-1,-2)) = 0 
 coeff(ma3( 0,-1,-2)) = 0 
 coeff(ma3( 1,-1,-2)) = 0 
 coeff(ma3( 2,-1,-2)) = 0 
 coeff(ma3(-2, 0,-2)) = 0 
 coeff(ma3(-1, 0,-2)) = 0 
 coeff(ma3( 0, 0,-2)) = 0 
 coeff(ma3( 1, 0,-2)) = 0 
 coeff(ma3( 2, 0,-2)) = 0 
 coeff(ma3(-2, 1,-2)) = 0 
 coeff(ma3(-1, 1,-2)) = 0 
 coeff(ma3( 0, 1,-2)) = 0 
 coeff(ma3( 1, 1,-2)) = 0 
 coeff(ma3( 2, 1,-2)) = 0 
 coeff(ma3(-2, 2,-2)) = 0 
 coeff(ma3(-1, 2,-2)) = 0 
 coeff(ma3( 0, 2,-2)) = 0 
 coeff(ma3( 1, 2,-2)) = 0 
 coeff(ma3( 2, 2,-2)) = 0 
 coeff(ma3(-2,-2,-1)) = 0 
 coeff(ma3(-1,-2,-1)) = 0 
 coeff(ma3( 0,-2,-1)) = 0 
 coeff(ma3( 1,-2,-1)) = 0 
 coeff(ma3( 2,-2,-1)) = 0 
 coeff(ma3(-2,-1,-1)) = 0 
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 0 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3( 2,-1,-1)) = 0 
 coeff(ma3(-2, 0,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 0 
 coeff(ma3( 0, 0,-1)) = 0 
 coeff(ma3( 1, 0,-1)) = 0 
 coeff(ma3( 2, 0,-1)) = 0 
 coeff(ma3(-2, 1,-1)) = 0 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = 0 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3( 2, 1,-1)) = 0 
 coeff(ma3(-2, 2,-1)) = 0 
 coeff(ma3(-1, 2,-1)) = 0 
 coeff(ma3( 0, 2,-1)) = 0 
 coeff(ma3( 1, 2,-1)) = 0 
 coeff(ma3( 2, 2,-1)) = 0 
 coeff(ma3(-2,-2, 0)) = 0 
 coeff(ma3(-1,-2, 0)) = 0 
 coeff(ma3( 0,-2, 0)) = 0 
 coeff(ma3( 1,-2, 0)) = 0 
 coeff(ma3( 2,-2, 0)) = 0 
 coeff(ma3(-2,-1, 0)) = 0 
 coeff(ma3(-1,-1, 0)) = 0 
 coeff(ma3( 0,-1, 0)) = 0 
 coeff(ma3( 1,-1, 0)) = 0 
 coeff(ma3( 2,-1, 0)) = 0 
 coeff(ma3(-2, 0, 0)) = 0 
 coeff(ma3(-1, 0, 0)) = 0 
 coeff(ma3( 0, 0, 0)) = 1. 
 coeff(ma3( 1, 0, 0)) = 0 
 coeff(ma3( 2, 0, 0)) = 0 
 coeff(ma3(-2, 1, 0)) = 0 
 coeff(ma3(-1, 1, 0)) = 0 
 coeff(ma3( 0, 1, 0)) = 0 
 coeff(ma3( 1, 1, 0)) = 0 
 coeff(ma3( 2, 1, 0)) = 0 
 coeff(ma3(-2, 2, 0)) = 0 
 coeff(ma3(-1, 2, 0)) = 0 
 coeff(ma3( 0, 2, 0)) = 0 
 coeff(ma3( 1, 2, 0)) = 0 
 coeff(ma3( 2, 2, 0)) = 0 
 coeff(ma3(-2,-2, 1)) = 0 
 coeff(ma3(-1,-2, 1)) = 0 
 coeff(ma3( 0,-2, 1)) = 0 
 coeff(ma3( 1,-2, 1)) = 0 
 coeff(ma3( 2,-2, 1)) = 0 
 coeff(ma3(-2,-1, 1)) = 0 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = 0 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3( 2,-1, 1)) = 0 
 coeff(ma3(-2, 0, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = 0 
 coeff(ma3( 0, 0, 1)) = 0 
 coeff(ma3( 1, 0, 1)) = 0 
 coeff(ma3( 2, 0, 1)) = 0 
 coeff(ma3(-2, 1, 1)) = 0 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 0 
 coeff(ma3( 1, 1, 1)) = 0 
 coeff(ma3( 2, 1, 1)) = 0 
 coeff(ma3(-2, 2, 1)) = 0 
 coeff(ma3(-1, 2, 1)) = 0 
 coeff(ma3( 0, 2, 1)) = 0 
 coeff(ma3( 1, 2, 1)) = 0 
 coeff(ma3( 2, 2, 1)) = 0 
 coeff(ma3(-2,-2, 2)) = 0 
 coeff(ma3(-1,-2, 2)) = 0 
 coeff(ma3( 0,-2, 2)) = 0 
 coeff(ma3( 1,-2, 2)) = 0 
 coeff(ma3( 2,-2, 2)) = 0 
 coeff(ma3(-2,-1, 2)) = 0 
 coeff(ma3(-1,-1, 2)) = 0 
 coeff(ma3( 0,-1, 2)) = 0 
 coeff(ma3( 1,-1, 2)) = 0 
 coeff(ma3( 2,-1, 2)) = 0 
 coeff(ma3(-2, 0, 2)) = 0 
 coeff(ma3(-1, 0, 2)) = 0 
 coeff(ma3( 0, 0, 2)) = 0 
 coeff(ma3( 1, 0, 2)) = 0 
 coeff(ma3( 2, 0, 2)) = 0 
 coeff(ma3(-2, 1, 2)) = 0 
 coeff(ma3(-1, 1, 2)) = 0 
 coeff(ma3( 0, 1, 2)) = 0 
 coeff(ma3( 1, 1, 2)) = 0 
 coeff(ma3( 2, 1, 2)) = 0 
 coeff(ma3(-2, 2, 2)) = 0 
 coeff(ma3(-1, 2, 2)) = 0 
 coeff(ma3( 0, 2, 2)) = 0 
 coeff(ma3( 1, 2, 2)) = 0 
 coeff(ma3( 2, 2, 2)) = 0 
#endMacro

#beginMacro identityCoeffOrder6Dim3(coeff,aj)
! Operator identity 
 coeff(ma3(-3,-3,-3)) = 0 
 coeff(ma3(-2,-3,-3)) = 0 
 coeff(ma3(-1,-3,-3)) = 0 
 coeff(ma3( 0,-3,-3)) = 0 
 coeff(ma3( 1,-3,-3)) = 0 
 coeff(ma3( 2,-3,-3)) = 0 
 coeff(ma3( 3,-3,-3)) = 0 
 coeff(ma3(-3,-2,-3)) = 0 
 coeff(ma3(-2,-2,-3)) = 0 
 coeff(ma3(-1,-2,-3)) = 0 
 coeff(ma3( 0,-2,-3)) = 0 
 coeff(ma3( 1,-2,-3)) = 0 
 coeff(ma3( 2,-2,-3)) = 0 
 coeff(ma3( 3,-2,-3)) = 0 
 coeff(ma3(-3,-1,-3)) = 0 
 coeff(ma3(-2,-1,-3)) = 0 
 coeff(ma3(-1,-1,-3)) = 0 
 coeff(ma3( 0,-1,-3)) = 0 
 coeff(ma3( 1,-1,-3)) = 0 
 coeff(ma3( 2,-1,-3)) = 0 
 coeff(ma3( 3,-1,-3)) = 0 
 coeff(ma3(-3, 0,-3)) = 0 
 coeff(ma3(-2, 0,-3)) = 0 
 coeff(ma3(-1, 0,-3)) = 0 
 coeff(ma3( 0, 0,-3)) = 0 
 coeff(ma3( 1, 0,-3)) = 0 
 coeff(ma3( 2, 0,-3)) = 0 
 coeff(ma3( 3, 0,-3)) = 0 
 coeff(ma3(-3, 1,-3)) = 0 
 coeff(ma3(-2, 1,-3)) = 0 
 coeff(ma3(-1, 1,-3)) = 0 
 coeff(ma3( 0, 1,-3)) = 0 
 coeff(ma3( 1, 1,-3)) = 0 
 coeff(ma3( 2, 1,-3)) = 0 
 coeff(ma3( 3, 1,-3)) = 0 
 coeff(ma3(-3, 2,-3)) = 0 
 coeff(ma3(-2, 2,-3)) = 0 
 coeff(ma3(-1, 2,-3)) = 0 
 coeff(ma3( 0, 2,-3)) = 0 
 coeff(ma3( 1, 2,-3)) = 0 
 coeff(ma3( 2, 2,-3)) = 0 
 coeff(ma3( 3, 2,-3)) = 0 
 coeff(ma3(-3, 3,-3)) = 0 
 coeff(ma3(-2, 3,-3)) = 0 
 coeff(ma3(-1, 3,-3)) = 0 
 coeff(ma3( 0, 3,-3)) = 0 
 coeff(ma3( 1, 3,-3)) = 0 
 coeff(ma3( 2, 3,-3)) = 0 
 coeff(ma3( 3, 3,-3)) = 0 
 coeff(ma3(-3,-3,-2)) = 0 
 coeff(ma3(-2,-3,-2)) = 0 
 coeff(ma3(-1,-3,-2)) = 0 
 coeff(ma3( 0,-3,-2)) = 0 
 coeff(ma3( 1,-3,-2)) = 0 
 coeff(ma3( 2,-3,-2)) = 0 
 coeff(ma3( 3,-3,-2)) = 0 
 coeff(ma3(-3,-2,-2)) = 0 
 coeff(ma3(-2,-2,-2)) = 0 
 coeff(ma3(-1,-2,-2)) = 0 
 coeff(ma3( 0,-2,-2)) = 0 
 coeff(ma3( 1,-2,-2)) = 0 
 coeff(ma3( 2,-2,-2)) = 0 
 coeff(ma3( 3,-2,-2)) = 0 
 coeff(ma3(-3,-1,-2)) = 0 
 coeff(ma3(-2,-1,-2)) = 0 
 coeff(ma3(-1,-1,-2)) = 0 
 coeff(ma3( 0,-1,-2)) = 0 
 coeff(ma3( 1,-1,-2)) = 0 
 coeff(ma3( 2,-1,-2)) = 0 
 coeff(ma3( 3,-1,-2)) = 0 
 coeff(ma3(-3, 0,-2)) = 0 
 coeff(ma3(-2, 0,-2)) = 0 
 coeff(ma3(-1, 0,-2)) = 0 
 coeff(ma3( 0, 0,-2)) = 0 
 coeff(ma3( 1, 0,-2)) = 0 
 coeff(ma3( 2, 0,-2)) = 0 
 coeff(ma3( 3, 0,-2)) = 0 
 coeff(ma3(-3, 1,-2)) = 0 
 coeff(ma3(-2, 1,-2)) = 0 
 coeff(ma3(-1, 1,-2)) = 0 
 coeff(ma3( 0, 1,-2)) = 0 
 coeff(ma3( 1, 1,-2)) = 0 
 coeff(ma3( 2, 1,-2)) = 0 
 coeff(ma3( 3, 1,-2)) = 0 
 coeff(ma3(-3, 2,-2)) = 0 
 coeff(ma3(-2, 2,-2)) = 0 
 coeff(ma3(-1, 2,-2)) = 0 
 coeff(ma3( 0, 2,-2)) = 0 
 coeff(ma3( 1, 2,-2)) = 0 
 coeff(ma3( 2, 2,-2)) = 0 
 coeff(ma3( 3, 2,-2)) = 0 
 coeff(ma3(-3, 3,-2)) = 0 
 coeff(ma3(-2, 3,-2)) = 0 
 coeff(ma3(-1, 3,-2)) = 0 
 coeff(ma3( 0, 3,-2)) = 0 
 coeff(ma3( 1, 3,-2)) = 0 
 coeff(ma3( 2, 3,-2)) = 0 
 coeff(ma3( 3, 3,-2)) = 0 
 coeff(ma3(-3,-3,-1)) = 0 
 coeff(ma3(-2,-3,-1)) = 0 
 coeff(ma3(-1,-3,-1)) = 0 
 coeff(ma3( 0,-3,-1)) = 0 
 coeff(ma3( 1,-3,-1)) = 0 
 coeff(ma3( 2,-3,-1)) = 0 
 coeff(ma3( 3,-3,-1)) = 0 
 coeff(ma3(-3,-2,-1)) = 0 
 coeff(ma3(-2,-2,-1)) = 0 
 coeff(ma3(-1,-2,-1)) = 0 
 coeff(ma3( 0,-2,-1)) = 0 
 coeff(ma3( 1,-2,-1)) = 0 
 coeff(ma3( 2,-2,-1)) = 0 
 coeff(ma3( 3,-2,-1)) = 0 
 coeff(ma3(-3,-1,-1)) = 0 
 coeff(ma3(-2,-1,-1)) = 0 
 coeff(ma3(-1,-1,-1)) = 0 
 coeff(ma3( 0,-1,-1)) = 0 
 coeff(ma3( 1,-1,-1)) = 0 
 coeff(ma3( 2,-1,-1)) = 0 
 coeff(ma3( 3,-1,-1)) = 0 
 coeff(ma3(-3, 0,-1)) = 0 
 coeff(ma3(-2, 0,-1)) = 0 
 coeff(ma3(-1, 0,-1)) = 0 
 coeff(ma3( 0, 0,-1)) = 0 
 coeff(ma3( 1, 0,-1)) = 0 
 coeff(ma3( 2, 0,-1)) = 0 
 coeff(ma3( 3, 0,-1)) = 0 
 coeff(ma3(-3, 1,-1)) = 0 
 coeff(ma3(-2, 1,-1)) = 0 
 coeff(ma3(-1, 1,-1)) = 0 
 coeff(ma3( 0, 1,-1)) = 0 
 coeff(ma3( 1, 1,-1)) = 0 
 coeff(ma3( 2, 1,-1)) = 0 
 coeff(ma3( 3, 1,-1)) = 0 
 coeff(ma3(-3, 2,-1)) = 0 
 coeff(ma3(-2, 2,-1)) = 0 
 coeff(ma3(-1, 2,-1)) = 0 
 coeff(ma3( 0, 2,-1)) = 0 
 coeff(ma3( 1, 2,-1)) = 0 
 coeff(ma3( 2, 2,-1)) = 0 
 coeff(ma3( 3, 2,-1)) = 0 
 coeff(ma3(-3, 3,-1)) = 0 
 coeff(ma3(-2, 3,-1)) = 0 
 coeff(ma3(-1, 3,-1)) = 0 
 coeff(ma3( 0, 3,-1)) = 0 
 coeff(ma3( 1, 3,-1)) = 0 
 coeff(ma3( 2, 3,-1)) = 0 
 coeff(ma3( 3, 3,-1)) = 0 
 coeff(ma3(-3,-3, 0)) = 0 
 coeff(ma3(-2,-3, 0)) = 0 
 coeff(ma3(-1,-3, 0)) = 0 
 coeff(ma3( 0,-3, 0)) = 0 
 coeff(ma3( 1,-3, 0)) = 0 
 coeff(ma3( 2,-3, 0)) = 0 
 coeff(ma3( 3,-3, 0)) = 0 
 coeff(ma3(-3,-2, 0)) = 0 
 coeff(ma3(-2,-2, 0)) = 0 
 coeff(ma3(-1,-2, 0)) = 0 
 coeff(ma3( 0,-2, 0)) = 0 
 coeff(ma3( 1,-2, 0)) = 0 
 coeff(ma3( 2,-2, 0)) = 0 
 coeff(ma3( 3,-2, 0)) = 0 
 coeff(ma3(-3,-1, 0)) = 0 
 coeff(ma3(-2,-1, 0)) = 0 
 coeff(ma3(-1,-1, 0)) = 0 
 coeff(ma3( 0,-1, 0)) = 0 
 coeff(ma3( 1,-1, 0)) = 0 
 coeff(ma3( 2,-1, 0)) = 0 
 coeff(ma3( 3,-1, 0)) = 0 
 coeff(ma3(-3, 0, 0)) = 0 
 coeff(ma3(-2, 0, 0)) = 0 
 coeff(ma3(-1, 0, 0)) = 0 
 coeff(ma3( 0, 0, 0)) = 1. 
 coeff(ma3( 1, 0, 0)) = 0 
 coeff(ma3( 2, 0, 0)) = 0 
 coeff(ma3( 3, 0, 0)) = 0 
 coeff(ma3(-3, 1, 0)) = 0 
 coeff(ma3(-2, 1, 0)) = 0 
 coeff(ma3(-1, 1, 0)) = 0 
 coeff(ma3( 0, 1, 0)) = 0 
 coeff(ma3( 1, 1, 0)) = 0 
 coeff(ma3( 2, 1, 0)) = 0 
 coeff(ma3( 3, 1, 0)) = 0 
 coeff(ma3(-3, 2, 0)) = 0 
 coeff(ma3(-2, 2, 0)) = 0 
 coeff(ma3(-1, 2, 0)) = 0 
 coeff(ma3( 0, 2, 0)) = 0 
 coeff(ma3( 1, 2, 0)) = 0 
 coeff(ma3( 2, 2, 0)) = 0 
 coeff(ma3( 3, 2, 0)) = 0 
 coeff(ma3(-3, 3, 0)) = 0 
 coeff(ma3(-2, 3, 0)) = 0 
 coeff(ma3(-1, 3, 0)) = 0 
 coeff(ma3( 0, 3, 0)) = 0 
 coeff(ma3( 1, 3, 0)) = 0 
 coeff(ma3( 2, 3, 0)) = 0 
 coeff(ma3( 3, 3, 0)) = 0 
 coeff(ma3(-3,-3, 1)) = 0 
 coeff(ma3(-2,-3, 1)) = 0 
 coeff(ma3(-1,-3, 1)) = 0 
 coeff(ma3( 0,-3, 1)) = 0 
 coeff(ma3( 1,-3, 1)) = 0 
 coeff(ma3( 2,-3, 1)) = 0 
 coeff(ma3( 3,-3, 1)) = 0 
 coeff(ma3(-3,-2, 1)) = 0 
 coeff(ma3(-2,-2, 1)) = 0 
 coeff(ma3(-1,-2, 1)) = 0 
 coeff(ma3( 0,-2, 1)) = 0 
 coeff(ma3( 1,-2, 1)) = 0 
 coeff(ma3( 2,-2, 1)) = 0 
 coeff(ma3( 3,-2, 1)) = 0 
 coeff(ma3(-3,-1, 1)) = 0 
 coeff(ma3(-2,-1, 1)) = 0 
 coeff(ma3(-1,-1, 1)) = 0 
 coeff(ma3( 0,-1, 1)) = 0 
 coeff(ma3( 1,-1, 1)) = 0 
 coeff(ma3( 2,-1, 1)) = 0 
 coeff(ma3( 3,-1, 1)) = 0 
 coeff(ma3(-3, 0, 1)) = 0 
 coeff(ma3(-2, 0, 1)) = 0 
 coeff(ma3(-1, 0, 1)) = 0 
 coeff(ma3( 0, 0, 1)) = 0 
 coeff(ma3( 1, 0, 1)) = 0 
 coeff(ma3( 2, 0, 1)) = 0 
 coeff(ma3( 3, 0, 1)) = 0 
 coeff(ma3(-3, 1, 1)) = 0 
 coeff(ma3(-2, 1, 1)) = 0 
 coeff(ma3(-1, 1, 1)) = 0 
 coeff(ma3( 0, 1, 1)) = 0 
 coeff(ma3( 1, 1, 1)) = 0 
 coeff(ma3( 2, 1, 1)) = 0 
 coeff(ma3( 3, 1, 1)) = 0 
 coeff(ma3(-3, 2, 1)) = 0 
 coeff(ma3(-2, 2, 1)) = 0 
 coeff(ma3(-1, 2, 1)) = 0 
 coeff(ma3( 0, 2, 1)) = 0 
 coeff(ma3( 1, 2, 1)) = 0 
 coeff(ma3( 2, 2, 1)) = 0 
 coeff(ma3( 3, 2, 1)) = 0 
 coeff(ma3(-3, 3, 1)) = 0 
 coeff(ma3(-2, 3, 1)) = 0 
 coeff(ma3(-1, 3, 1)) = 0 
 coeff(ma3( 0, 3, 1)) = 0 
 coeff(ma3( 1, 3, 1)) = 0 
 coeff(ma3( 2, 3, 1)) = 0 
 coeff(ma3( 3, 3, 1)) = 0 
 coeff(ma3(-3,-3, 2)) = 0 
 coeff(ma3(-2,-3, 2)) = 0 
 coeff(ma3(-1,-3, 2)) = 0 
 coeff(ma3( 0,-3, 2)) = 0 
 coeff(ma3( 1,-3, 2)) = 0 
 coeff(ma3( 2,-3, 2)) = 0 
 coeff(ma3( 3,-3, 2)) = 0 
 coeff(ma3(-3,-2, 2)) = 0 
 coeff(ma3(-2,-2, 2)) = 0 
 coeff(ma3(-1,-2, 2)) = 0 
 coeff(ma3( 0,-2, 2)) = 0 
 coeff(ma3( 1,-2, 2)) = 0 
 coeff(ma3( 2,-2, 2)) = 0 
 coeff(ma3( 3,-2, 2)) = 0 
 coeff(ma3(-3,-1, 2)) = 0 
 coeff(ma3(-2,-1, 2)) = 0 
 coeff(ma3(-1,-1, 2)) = 0 
 coeff(ma3( 0,-1, 2)) = 0 
 coeff(ma3( 1,-1, 2)) = 0 
 coeff(ma3( 2,-1, 2)) = 0 
 coeff(ma3( 3,-1, 2)) = 0 
 coeff(ma3(-3, 0, 2)) = 0 
 coeff(ma3(-2, 0, 2)) = 0 
 coeff(ma3(-1, 0, 2)) = 0 
 coeff(ma3( 0, 0, 2)) = 0 
 coeff(ma3( 1, 0, 2)) = 0 
 coeff(ma3( 2, 0, 2)) = 0 
 coeff(ma3( 3, 0, 2)) = 0 
 coeff(ma3(-3, 1, 2)) = 0 
 coeff(ma3(-2, 1, 2)) = 0 
 coeff(ma3(-1, 1, 2)) = 0 
 coeff(ma3( 0, 1, 2)) = 0 
 coeff(ma3( 1, 1, 2)) = 0 
 coeff(ma3( 2, 1, 2)) = 0 
 coeff(ma3( 3, 1, 2)) = 0 
 coeff(ma3(-3, 2, 2)) = 0 
 coeff(ma3(-2, 2, 2)) = 0 
 coeff(ma3(-1, 2, 2)) = 0 
 coeff(ma3( 0, 2, 2)) = 0 
 coeff(ma3( 1, 2, 2)) = 0 
 coeff(ma3( 2, 2, 2)) = 0 
 coeff(ma3( 3, 2, 2)) = 0 
 coeff(ma3(-3, 3, 2)) = 0 
 coeff(ma3(-2, 3, 2)) = 0 
 coeff(ma3(-1, 3, 2)) = 0 
 coeff(ma3( 0, 3, 2)) = 0 
 coeff(ma3( 1, 3, 2)) = 0 
 coeff(ma3( 2, 3, 2)) = 0 
 coeff(ma3( 3, 3, 2)) = 0 
 coeff(ma3(-3,-3, 3)) = 0 
 coeff(ma3(-2,-3, 3)) = 0 
 coeff(ma3(-1,-3, 3)) = 0 
 coeff(ma3( 0,-3, 3)) = 0 
 coeff(ma3( 1,-3, 3)) = 0 
 coeff(ma3( 2,-3, 3)) = 0 
 coeff(ma3( 3,-3, 3)) = 0 
 coeff(ma3(-3,-2, 3)) = 0 
 coeff(ma3(-2,-2, 3)) = 0 
 coeff(ma3(-1,-2, 3)) = 0 
 coeff(ma3( 0,-2, 3)) = 0 
 coeff(ma3( 1,-2, 3)) = 0 
 coeff(ma3( 2,-2, 3)) = 0 
 coeff(ma3( 3,-2, 3)) = 0 
 coeff(ma3(-3,-1, 3)) = 0 
 coeff(ma3(-2,-1, 3)) = 0 
 coeff(ma3(-1,-1, 3)) = 0 
 coeff(ma3( 0,-1, 3)) = 0 
 coeff(ma3( 1,-1, 3)) = 0 
 coeff(ma3( 2,-1, 3)) = 0 
 coeff(ma3( 3,-1, 3)) = 0 
 coeff(ma3(-3, 0, 3)) = 0 
 coeff(ma3(-2, 0, 3)) = 0 
 coeff(ma3(-1, 0, 3)) = 0 
 coeff(ma3( 0, 0, 3)) = 0 
 coeff(ma3( 1, 0, 3)) = 0 
 coeff(ma3( 2, 0, 3)) = 0 
 coeff(ma3( 3, 0, 3)) = 0 
 coeff(ma3(-3, 1, 3)) = 0 
 coeff(ma3(-2, 1, 3)) = 0 
 coeff(ma3(-1, 1, 3)) = 0 
 coeff(ma3( 0, 1, 3)) = 0 
 coeff(ma3( 1, 1, 3)) = 0 
 coeff(ma3( 2, 1, 3)) = 0 
 coeff(ma3( 3, 1, 3)) = 0 
 coeff(ma3(-3, 2, 3)) = 0 
 coeff(ma3(-2, 2, 3)) = 0 
 coeff(ma3(-1, 2, 3)) = 0 
 coeff(ma3( 0, 2, 3)) = 0 
 coeff(ma3( 1, 2, 3)) = 0 
 coeff(ma3( 2, 2, 3)) = 0 
 coeff(ma3( 3, 2, 3)) = 0 
 coeff(ma3(-3, 3, 3)) = 0 
 coeff(ma3(-2, 3, 3)) = 0 
 coeff(ma3(-1, 3, 3)) = 0 
 coeff(ma3( 0, 3, 3)) = 0 
 coeff(ma3( 1, 3, 3)) = 0 
 coeff(ma3( 2, 3, 3)) = 0 
 coeff(ma3( 3, 3, 3)) = 0 
#endMacro

